#ifndef COMMCTRL_H
#define COMMCTRL_H

/*
Switches available:
CCMOUSEEVENT = TrackMouseEvent function defaults to the common controls version
CCUSEORDINALS = Default to settlement API functions is by ordinal
COMCTLVER = Common controls version XXX (ie 4.72 would be 472 - three digits only)
WINCE = Set definitions for Windows CE (note: some are not compatible with 9x/NT)
UNICODE = Use UNICODE versions
*/

#IFNDEF COMCTLVER
	#DEFINE COMCTLVER 600
#ENDIF

/* Windows Common Controls definitions */

#IFDEF LINKFILES
	#dynamiclinkfile comctl32.dll
#ENDIF

#IFNDEF NMHDR
#IFDEF WIN64
	NMHDR STRUCT
		hwndFrom DQ
		idFrom DQ
		code DD
	ENDS
#ELSE
	NMHDR STRUCT
		hwndFrom DD
		idFrom DD
		code DD
	ENDS
#ENDIF
#ENDIF

#IFNDEF POINT
	POINT STRUCT
		x DD
		y DD
	ENDS
#ENDIF

// For MASM32 compatibility purposes only
#DEFINE _SIZE POINT

#IFNDEF SIZE
	SIZE STRUCT
		cx DD
		cy DD
	ENDS
#ENDIF

#IFNDEF RECT
	RECT STRUCT
		left DD
		top DD
		right DD
		bottom DD
	ENDS
#ENDIF

#IFNDEF SYSTEMTIME
	SYSTEMTIME STRUCT
		wYear DW
		wMonth DW
		wDayOfWeek DW
		wDay DW
		wHour DW
		wMinute DW
		wSecond DW
		wMilliseconds DW
	ENDS
#ENDIF

INITCOMMONCONTROLSEX STRUCT
	dwSize DD
	dwICC DD
ENDS

#define ICC_LISTVIEW_CLASSES  0x00000001
#define ICC_TREEVIEW_CLASSES  0x00000002
#define ICC_BAR_CLASSES  0x00000004
#define ICC_TAB_CLASSES  0x00000008
#define ICC_UPDOWN_CLASS  0x00000010
#define ICC_PROGRESS_CLASS  0x00000020
#define ICC_HOTKEY_CLASS  0x00000040
#define ICC_ANIMATE_CLASS  0x00000080
#define ICC_WIN95_CLASSES  0x000000FF
#define ICC_DATE_CLASSES  0x00000100
#define ICC_USEREX_CLASSES  0x00000200
#define ICC_COOL_CLASSES  0x00000400
#define ICC_INTERNET_CLASSES  0x00000800
#define ICC_PAGESCROLLER_CLASS  0x00001000
#define ICC_NATIVEFNTCTL_CLASS  0x00002000
#define ICC_STANDARD_CLASSES  0x00004000
#define ICC_LINK_CLASS  0x00008000

#define ODT_HEADER  100
#define ODT_TAB  101
#define ODT_LISTVIEW  102

/* Ranges for control message IDs *******************************************/

#define LVM_FIRST  0x1000
#define TV_FIRST  0x1100
#define HDM_FIRST  0x1200
#define TCM_FIRST  0x1300

#define PGM_FIRST  0x1400
#define ECM_FIRST  0x1500
#define BCM_FIRST  0x1600
#define CBM_FIRST  0x1700
#define CCM_FIRST  0x2000
#define CCM_LAST  (CCM_FIRST+0x200)
#define CCM_SETBKCOLOR  (CCM_FIRST+1)

COLORSCHEME STRUCT
	dwSize DD
	clrBtnHighlight DD
	clrBtnShadow DD
ENDS

#define CCM_SETCOLORSCHEME  (CCM_FIRST+2)
#define CCM_GETCOLORSCHEME  (CCM_FIRST+3)
#define CCM_GETDROPTARGET  (CCM_FIRST+4)
#define CCM_SETUNICODEFORMAT  (CCM_FIRST+5)
#define CCM_GETUNICODEFORMAT  (CCM_FIRST+6)
#define COMCTL32_VERSION  5
#define CCM_SETVERSION  (CCM_FIRST+7)
#define CCM_GETVERSION  (CCM_FIRST+8)
#define CCM_SETNOTIFYWINDOW  (CCM_FIRST+9)
#define CCM_SETWINDOWTHEME  (CCM_FIRST+0xb)
#define CCM_DPISCALE  (CCM_FIRST+0xc)
#define INFOTIPSIZE  1024

/* Generic WM_NOTIFY notifications ******************************************/

#define NM_OUTOFMEMORY  (NM_FIRST-1)
#define NM_CLICK  (NM_FIRST-2)
#define NM_DBLCLK  (NM_FIRST-3)
#define NM_RETURN  (NM_FIRST-4)
#define NM_RCLICK  (NM_FIRST-5)
#define NM_RDBLCLK  (NM_FIRST-6)
#define NM_SETFOCUS  (NM_FIRST-7)
#define NM_KILLFOCUS  (NM_FIRST-8)
#define NM_CUSTOMDRAW  (NM_FIRST-12)
#define NM_HOVER  (NM_FIRST-13)
#define NM_NCHITTEST  (NM_FIRST-14)
#define NM_KEYDOWN  (NM_FIRST-15)
#define NM_RELEASEDCAPTURE  (NM_FIRST-16)
#define NM_SETCURSOR  (NM_FIRST-17)
#define NM_CHAR  (NM_FIRST-18)
#define NM_TOOLTIPSCREATED  (NM_FIRST-19)
#define NM_LDOWN  (NM_FIRST-20)
#define NM_RDOWN  (NM_FIRST-21)
#define NM_THEMECHANGED (NM_FIRST-22)
#define NM_FONTCHANGED (NM_FIRST-23)
#define NM_CUSTOMTEXT (NM_FIRST-24)   // uses NMCUSTOMTEXT struct
#define NM_TVSTATEIMAGECHANGING(NM_FIRST-24)   // uses NMTVSTATEIMAGECHANGING struct, defined after HTREEITEM

NMTOOLTIPSCREATED STRUCT
	hdr NMHDR
	hwndToolTips DD
ENDS

NMMOUSE STRUCT
	hdr NMHDR
	dwItemSpec DD
	dwItemData DD
	pt POINT
	dwHitInfo DD
ENDS

NMOBJECTNOTIFY STRUCT
	hdr NMHDR
	iItem DD
	piid PTR
	pObject PTR
	hResult HANDLE
	dwFlags DD
ENDS

NMKEY STRUCT
	hdr NMHDR
	nVKey DD
	uFlags DD
ENDS

NMCHAR STRUCT
	hdr NMHDR
	ch DD
	dwItemPrev DD
	dwItemNext DD
ENDS

NMCUSTOMTEXT STRUCT
	hdr NMHDR
	hDC HANDLE
	lpString PTR
	nCount DD
	lpRect PTR
	uFormat DD
	fLink DD
ENDS

#define NM_FIRST  0
#define NM_LAST  -99
#define LVN_FIRST  -100
#define LVN_LAST  -199
#define HDN_FIRST  -300
#define HDN_LAST  -399
#define TVN_FIRST  -400
#define TVN_LAST  -499
#define TTN_FIRST  -520
#define TTN_LAST  -549
#define TCN_FIRST  -550
#define TCN_LAST  -580
#define CDN_FIRST  -601
#define CDN_LAST  -699
#define TBN_FIRST  -700
#define TBN_LAST  -720
#define UDN_FIRST  -721
#define UDN_LAST  -740
#define MCN_FIRST  -750
#define MCN_LAST  -759
#define DTN_FIRST  -760
#define DTN_LAST  -799
#define DTN_FIRST2 -753
#define DTN_LAST2 -799
#define CBEN_FIRST  -800
#define CBEN_LAST  -830
#define RBN_FIRST  -831
#define RBN_LAST  -859
#define IPN_FIRST  -860
#define IPN_LAST  -879
#define SBN_FIRST  -880
#define SBN_LAST  -899
#define PGN_FIRST  -900
#define PGN_LAST  -950

#ifndef WMN_FIRST
	#define WMN_FIRST  -1000
	#define WMN_LAST  -1200
#endif

#define BCN_FIRST  -1250
#define BCN_LAST  -1350

#define TRBN_FIRST -1501
#define TRBN_LAST -1519

#define MSGF_COMMCTRL_BEGINDRAG  0x4200
#define MSGF_COMMCTRL_SIZEHEADER  0x4201
#define MSGF_COMMCTRL_DRAGSELECT  0x4202
#define MSGF_COMMCTRL_TOOLBARCUST  0x4203

/* Common Control Styles ****************************************************/

#define CCS_TOP  0x00000001
#define CCS_NOMOVEY  0x00000002
#define CCS_BOTTOM  0x00000003
#define CCS_NORESIZE  0x00000004
#define CCS_NOPARENTALIGN  0x00000008
#define CCS_ADJUSTABLE  0x00000020
#define CCS_NODIVIDER  0x00000040
#define CCS_VERT  0x00000080
#define CCS_LEFT  (CCS_VERT|CCS_TOP)
#define CCS_RIGHT  (CCS_VERT|CCS_BOTTOM)
#define CCS_NOMOVEX  (CCS_VERT|CCS_NOMOVEY)

/* Custom Draw **************************************************************/

#define CDRF_DODEFAULT  0x00000000
#define CDRF_NEWFONT  0x00000002
#define CDRF_SKIPDEFAULT  0x00000004
#define CDRF_DOERASE 0x00000008
#define CDRF_SKIPPOSTPAINT 0x00000100

#define CDRF_NOTIFYPOSTPAINT  0x00000010
#define CDRF_NOTIFYITEMDRAW  0x00000020
#define CDRF_NOTIFYSUBITEMDRAW  0x00000020
#define CDRF_NOTIFYPOSTERASE  0x00000040

#define CDDS_PREPAINT  0x00000001
#define CDDS_POSTPAINT  0x00000002
#define CDDS_PREERASE  0x00000003
#define CDDS_POSTERASE  0x00000004
#define CDDS_ITEM  0x00010000
#define CDDS_ITEMPREPAINT  (CDDS_ITEM|CDDS_PREPAINT)
#define CDDS_ITEMPOSTPAINT  (CDDS_ITEM|CDDS_POSTPAINT)
#define CDDS_ITEMPREERASE  (CDDS_ITEM|CDDS_PREERASE)
#define CDDS_ITEMPOSTERASE  (CDDS_ITEM|CDDS_POSTERASE)
#define CDDS_SUBITEM  0x00020000

#define CDIS_SELECTED  0x0001
#define CDIS_GRAYED  0x0002
#define CDIS_DISABLED  0x0004
#define CDIS_CHECKED  0x0008
#define CDIS_FOCUS  0x0010
#define CDIS_DEFAULT  0x0020
#define CDIS_HOT  0x0040
#define CDIS_MARKED  0x0080
#define CDIS_INDETERMINATE  0x0100
#define CDIS_SHOWKEYBOARDCUES  0x0200
#define CDIS_NEARHOT 0x0400
#define CDIS_OTHERSIDEHOT 0x0800
#define CDIS_DROPHILITED 0x1000

NMCUSTOMDRAW STRUCT
	hdr NMHDR
	dwDrawStage DD
	hdc DD
	rc RECT
	dwItemSpec DD
	uItemState DD
	lItemlParam DD
ENDS

NMTTCUSTOMDRAW STRUCT
	nmcd NMCUSTOMDRAW
	uDrawFlags DD
ENDS

/* ImageList API ************************************************************/

#define CLR_NONE  0xFFFFFFFFL
#define CLR_DEFAULT  0xFF000000L

IMAGELISTDRAWPARAMS STRUCT
	cbSize DD
	himl HANDLE
	i DD
	hdcDst HANDLE
	x DD
	y DD
	cx DD
	cy DD
	xBitmap DD
	yBitmap DD
	rgbBk DD
	rgbFg DD
	fStyle DD
	dwRop DD
	fState DD
	Frame DD
	crEffect DD
ENDS

#define ILC_MASK  0x0001
#define ILC_COLOR  0x0000
#define ILC_COLORDDB  0x00FE
#define ILC_COLOR4  0x0004
#define ILC_COLOR8  0x0008
#define ILC_COLOR16  0x0010
#define ILC_COLOR24  0x0018
#define ILC_COLOR32  0x0020
#define ILC_PALETTE  0x0800
#define ILC_MIRROR  0x00002000
#define ILC_PERITEMMIRROR  0x00008000

#define ILD_NORMAL  0x0000
#define ILD_TRANSPARENT  0x0001
#define ILD_MASK  0x0010
#define ILD_IMAGE  0x0020
#define ILD_ROP  0x0040
#define ILD_BLEND25  0x0002
#define ILD_BLEND50  0x0004
#define ILD_OVERLAYMASK  0x0F00
#define ILD_PRESERVEALPHA 0x00001000  // This preserves the alpha channel in dest
#define ILD_SCALE 0x00002000  // Causes the image to be scaled to cx, cy instead of clipped
#define ILD_DPISCALE 0x00004000
#define ILD_ASYNC 0x00008000

#define ILD_SELECTED  ILD_BLEND50
#define ILD_FOCUS  ILD_BLEND25
#define ILD_BLEND  ILD_BLEND50
#define CLR_HILIGHT  CLR_DEFAULT

#define ILS_NORMAL 0x00000000
#define ILS_GLOW 0x00000001
#define ILS_SHADOW 0x00000002
#define ILS_SATURATE 0x00000004
#define ILS_ALPHA 0x00000008

#define ILGT_NORMAL 0x00000000
#define ILGT_ASYNC 0x00000001

#define ILCF_MOVE  0x00000000
#define ILCF_SWAP  0x00000001

#define ILP_NORMAL  0
#define ILP_DOWNLEVEL  1

IMAGEINFO STRUCT
	hbmImage HANDLE
	hbmMask HANDLE
	Unused1 DD
	Unused2 DD
	rcImage RECT
ENDS

#IFDEF UNICODE
	#define ImageList_LoadImage ImageList_LoadImageW
#ELSE
	#define ImageList_LoadImage ImageList_LoadImageA
#ENDIF


/* Header Control ***********************************************************/

#define WC_HEADERA  A"SysHeader32"
#define WC_HEADERW  L"SysHeader32"

#define HDS_HORZ  0x0000
#define HDS_BUTTONS  0x0002
#define HDS_HOTTRACK  0x0004
#define HDS_HIDDEN  0x0008

#define HDS_DRAGDROP  0x0040
#define HDS_FULLDRAG  0x0080
#define HDS_FILTERBAR  0x0100
#define HDS_FLAT  0x0200

#define HDS_CHECKBOXES 0x0400
#define HDS_NOSIZING 0x0800
#define HDS_OVERFLOW 0x1000

#define HDFT_ISSTRING  0x0000
#define HDFT_ISNUMBER  0x0001
#define HDFT_ISDATE 0x0002
#define HDFT_HASNOVALUE  0x8000

#define HDI_WIDTH  0x0001
#define HDI_HEIGHT  HDI_WIDTH
#define HDI_TEXT  0x0002
#define HDI_FORMAT  0x0004
#define HDI_LPARAM  0x0008
#define HDI_BITMAP  0x0010
#define HDI_IMAGE  0x0020
#define HDI_DI_SETITEM  0x0040
#define HDI_ORDER  0x0080
#define HDI_FILTER  0x0100
#define HDI_STATE 0x0200

#define HDF_LEFT  0
#define HDF_RIGHT  1
#define HDF_CENTER  2
#define HDF_JUSTIFYMASK  0x0003
#define HDF_RTLREADING  4

#define HDF_OWNERDRAW  0x8000
#define HDF_STRING  0x4000
#define HDF_BITMAP  0x2000
#define HDF_BITMAP_ON_RIGHT 0x1000
#define HDF_IMAGE  0x0800
#define HDF_SORTUP  0x0400
#define HDF_SORTDOWN  0x0200
#define HDF_CHECKBOX 0x0040
#define HDF_CHECKED 0x0080
#define HDF_FIXEDWIDTH 0x0100 // Can't resize the column; same as LVCFMT_FIXED_WIDTH
#define HDF_SPLITBUTTON 0x1000000 // Column is a split button; same as LVCFMT_SPLITBUTTON

#define HDIS_FOCUSED 0x00000001

#define HHT_NOWHERE  0x0001
#define HHT_ONHEADER  0x0002
#define HHT_ONDIVIDER  0x0004
#define HHT_ONDIVOPEN  0x0008
#define HHT_ONFILTER  0x0010
#define HHT_ONFILTERBUTTON  0x0020
#define HHT_ABOVE  0x0100
#define HHT_BELOW  0x0200
#define HHT_TORIGHT  0x0400
#define HHT_TOLEFT  0x0800
#define HHT_ONITEMSTATEICON 0x1000
#define HHT_ONDROPDOWN 0x2000
#define HHT_ONOVERFLOW 0x4000

#define HDM_GETITEMCOUNT  (HDM_FIRST+0)
#define HDM_INSERTITEMA  (HDM_FIRST+1)
#define HDM_INSERTITEMW  (HDM_FIRST+10)
#define HDM_DELETEITEM  (HDM_FIRST+2)
#define HDM_GETITEMA  (HDM_FIRST+3)
#define HDM_GETITEMW  (HDM_FIRST+11)
#define HDM_SETITEMA  (HDM_FIRST+4)
#define HDM_SETITEMW  (HDM_FIRST+12)
#define HDM_LAYOUT  (HDM_FIRST+5)
#define HDM_HITTEST  (HDM_FIRST+6)
#define HDM_GETITEMRECT  (HDM_FIRST+7)
#define HDM_SETIMAGELIST  (HDM_FIRST+8)
#define HDM_GETIMAGELIST  (HDM_FIRST+9)
#define HDM_ORDERTOINDEX  (HDM_FIRST+15)
#define HDM_CREATEDRAGIMAGE  (HDM_FIRST+16)
#define HDM_GETORDERARRAY  (HDM_FIRST+17)
#define HDM_SETORDERARRAY  (HDM_FIRST+18)
#define HDM_SETHOTDIVIDER  (HDM_FIRST+19)
#define HDM_SETBITMAPMARGIN  (HDM_FIRST+20)
#define HDM_GETBITMAPMARGIN  (HDM_FIRST+21)
#define HDM_SETFILTERCHANGETIMEOUT (HDM_FIRST+22)
#define HDM_EDITFILTER  (HDM_FIRST+23)
#define HDM_CLEARFILTER  (HDM_FIRST+24)
#define HDM_GETITEMDROPDOWNRECT (HDM_FIRST+25)
#define HDM_GETOVERFLOWRECT (HDM_FIRST+26)
#define HDM_GETFOCUSEDITEM (HDM_FIRST+27)
#define HDM_SETFOCUSEDITEM (HDM_FIRST+28)

#define HDM_TRANSLATEACCELERATOR    CCM_TRANSLATEACCELERATOR
#define HDM_SETUNICODEFORMAT  CCM_SETUNICODEFORMAT
#define HDM_GETUNICODEFORMAT  CCM_GETUNICODEFORMAT

#define HDN_ITEMCHANGINGA  (HDN_FIRST-0)
#define HDN_ITEMCHANGINGW  (HDN_FIRST-20)
#define HDN_ITEMCHANGEDA  (HDN_FIRST-1)
#define HDN_ITEMCHANGEDW  (HDN_FIRST-21)
#define HDN_ITEMCLICKA  (HDN_FIRST-2)
#define HDN_ITEMCLICKW  (HDN_FIRST-22)
#define HDN_ITEMDBLCLICKA  (HDN_FIRST-3)
#define HDN_ITEMDBLCLICKW  (HDN_FIRST-23)
#define HDN_DIVIDERDBLCLICKA  (HDN_FIRST-5)
#define HDN_DIVIDERDBLCLICKW  (HDN_FIRST-25)
#define HDN_BEGINTRACKA  (HDN_FIRST-6)
#define HDN_BEGINTRACKW  (HDN_FIRST-26)
#define HDN_ENDTRACKA  (HDN_FIRST-7)
#define HDN_ENDTRACKW  (HDN_FIRST-27)
#define HDN_TRACKA  (HDN_FIRST-8)
#define HDN_TRACKW  (HDN_FIRST-28)
#define HDN_GETDISPINFOA  (HDN_FIRST-9)
#define HDN_GETDISPINFOW  (HDN_FIRST-29)
#define HDN_BEGINDRAG  (HDN_FIRST-10)
#define HDN_ENDDRAG  (HDN_FIRST-11)
#define HDN_FILTERCHANGE  (HDN_FIRST-12)
#define HDN_FILTERBTNCLICK  (HDN_FIRST-13)
#define HDN_BEGINFILTEREDIT (HDN_FIRST-14)
#define HDN_ENDFILTEREDIT (HDN_FIRST-15)
#define HDN_ITEMSTATEICONCLICK (HDN_FIRST-16)
#define HDN_ITEMKEYDOWN (HDN_FIRST-17)
#define HDN_DROPDOWN (HDN_FIRST-18)
#define HDN_OVERFLOWCLICK (HDN_FIRST-19)

#define HD_LAYOUT HDLAYOUT
#define HD_HITTESTINFO HDHITTESTINFO

#define HD_NOTIFYA NMHEADERA
#define HD_NOTIFYW NMHEADERW
#define HD_NOTIFY NMHEADER

HD_TEXTFILTERA STRUCT
	pszText PTR
	cchTextMax DD
ENDS

HD_TEXTFILTERW = HD_TEXTFILTERA

HDITEMA STRUCT
	mask DD
	cxy DD
	pszText PTR
	hbm HANDLE
	cchTextMax DD
	fmt DD
	lParam DD
	iImage DD
	iOrder DD
	type DD
	pvFilter PTR
	State DD
ENDS

HDITEMW = HDITEMA
HD_ITEMA = HDITEMA
HD_ITEMW = HDITEMA

HDLAYOUT STRUCT
	prc PTR
	pwpos PTR
ENDS

HDHITTESTINFO STRUCT
	pt POINT
	flags DD
	iItem DD
ENDS

NMHEADERA STRUCT
	hdr NMHDR
	iItem DD
	iButton DD
	pitem PTR
ENDS

#define NMHEADERW NMHEADERA

NMHDDISPINFOA STRUCT
	hdr NMHDR
	iItem DD
	mask DD
	pszText PTR
	cchTextMax DD
	iImage DD
	lParam DD
ENDS

#define NMHDDISPINFOW NMHDDISPINFOA

NMHDFILTERBTNCLICK STRUCT
	hdr NMHDR
	iItem DD
	rc RECT
ENDS

#IFDEF UNICODE
	#define WC_HEADER  WC_HEADERW
	#define HD_TEXTFILTER HD_TEXTFILTERW
	#define HDTEXTFILTER HD_TEXTFILTERW
	#define HDITEM HDITEMW
	#define HD_ITEM HD_ITEMW
	#define HDITEM_V1_SIZE HDITEMW_V1_SIZE
	#define NMHEADER NMHEADERW
	#define NMHDDISPINFO NMHDDISPINFOW
	#define HDM_INSERTITEM HDM_INSERTITEMW
	#define HDM_GETITEM HDM_GETITEMW
	#define HDM_SETITEM HDM_SETITEMW
	#define HDN_ITEMCHANGING HDN_ITEMCHANGINGW
	#define HDN_ITEMCHANGED HDN_ITEMCHANGEDW
	#define HDN_ITEMCLICK HDN_ITEMCLICKW
	#define HDN_ITEMDBLCLICK HDN_ITEMDBLCLICKW
	#define HDN_DIVIDERDBLCLICK HDN_DIVIDERDBLCLICKW
	#define HDN_BEGINTRACK HDN_BEGINTRACKW
	#define HDN_ENDTRACK HDN_ENDTRACKW
	#define HDN_TRACK HDN_TRACKW
	#define HDN_GETDISPINFO HDN_GETDISPINFOW
#ELSE
	#define WC_HEADER  WC_HEADERA
	#define HD_TEXTFILTER HD_TEXTFILTERA
	#define HDTEXTFILTER HD_TEXTFILTERA
	#define HDITEM HDITEMA
	#define HD_ITEM HD_ITEMA
	#define HDITEM_V1_SIZE HDITEMA_V1_SIZE
	#define NMHEADER NMHEADERA
	#define NMHDDISPINFO NMHDDISPINFOA
	#define HDM_INSERTITEM HDM_INSERTITEMA
	#define HDM_GETITEM HDM_GETITEMA
	#define HDM_SETITEM HDM_SETITEMA
	#define HDN_ITEMCHANGING HDN_ITEMCHANGINGA
	#define HDN_ITEMCHANGED HDN_ITEMCHANGEDA
	#define HDN_ITEMCLICK HDN_ITEMCLICKA
	#define HDN_ITEMDBLCLICK HDN_ITEMDBLCLICKA
	#define HDN_DIVIDERDBLCLICK HDN_DIVIDERDBLCLICKA
	#define HDN_BEGINTRACK HDN_BEGINTRACKA
	#define HDN_ENDTRACK HDN_ENDTRACKA
	#define HDN_TRACK HDN_TRACKA
	#define HDN_GETDISPINFO HDN_GETDISPINFOA
#ENDIF


/* Toolbar Control **********************************************************/

#define TOOLBARCLASSNAMEW  L"ToolbarWindow32"
#define TOOLBARCLASSNAMEA  A"ToolbarWindow32"

#define CMB_MASKED  0x02
#define TBSTATE_CHECKED  0x01
#define TBSTATE_PRESSED  0x02
#define TBSTATE_ENABLED  0x04
#define TBSTATE_HIDDEN  0x08
#define TBSTATE_INDETERMINATE  0x10
#define TBSTATE_WRAP  0x20
#define TBSTATE_ELLIPSES  0x40
#define TBSTATE_MARKED  0x80
#define TBSTATE_HIGHLIGHTED  0x80

#define TBSTYLE_BUTTON  0x0000
#define TBSTYLE_SEP  0x0001
#define TBSTYLE_CHECK  0x0002
#define TBSTYLE_GROUP  0x0004
#define TBSTYLE_CHECKGROUP  (TBSTYLE_GROUP|TBSTYLE_CHECK)
#define TBSTYLE_DROPDOWN  0x0008
#define TBSTYLE_AUTOSIZE  0x0010
#define TBSTYLE_NOPREFIX  0x0020

#define TBSTYLE_TOOLTIPS  0x0100
#define TBSTYLE_WRAPABLE  0x0200
#define TBSTYLE_ALTDRAG  0x0400
#define TBSTYLE_FLAT  0x0800
#define TBSTYLE_LIST  0x1000
#define TBSTYLE_CUSTOMERASE  0x2000
#define TBSTYLE_REGISTERDROP  0x4000
#define TBSTYLE_TRANSPARENT  0x8000

#define TBSTYLE_EX_DRAWDDARROWS 0x00000001

#define BTNS_BUTTON  TBSTYLE_BUTTON
#define BTNS_SEP  TBSTYLE_SEP
#define BTNS_CHECK  TBSTYLE_CHECK
#define BTNS_GROUP  TBSTYLE_GROUP
#define BTNS_CHECKGROUP  TBSTYLE_CHECKGROUP
#define BTNS_DROPDOWN  TBSTYLE_DROPDOWN
#define BTNS_AUTOSIZE  TBSTYLE_AUTOSIZE
#define BTNS_NOPREFIX  TBSTYLE_NOPREFIX
#define BTNS_WHOLEDROPDOWN  0x0080
#define BTNS_SHOWTEXT  0x0040

#define TBSTYLE_EX_MIXEDBUTTONS  0x00000008
#define TBSTYLE_EX_HIDECLIPPEDBUTTONS  0x00000010
#define TBSTYLE_EX_DOUBLEBUFFER  0x00000080

#define TBCDRF_NOEDGES  0x00010000
#define TBCDRF_HILITEHOTTRACK  0x00020000
#define TBCDRF_NOOFFSET  0x00040000
#define TBCDRF_NOMARK  0x00080000
#define TBCDRF_NOETCHEDEFFECT  0x00100000
#define TBCDRF_BLENDICON  0x00200000
#define TBCDRF_NOBACKGROUND 0x00400000
#define TBCDRF_USECDCOLORS 0x00800000

#define TBIMHT_AFTER  0x00000001
#define TBIMHT_BACKGROUND  0x00000002

#define TBIF_IMAGE  0x00000001
#define TBIF_TEXT  0x00000002
#define TBIF_STATE  0x00000004
#define TBIF_STYLE  0x00000008
#define TBIF_LPARAM  0x00000010
#define TBIF_COMMAND  0x00000020
#define TBIF_SIZE  0x00000040
#define TBIF_BYINDEX  0x80000000

#define TBBF_LARGE  0x0001

#define TBNRF_HIDEHELP  0x00000001
#define TBNRF_ENDCUSTOMIZE  0x00000002

#define TBNF_IMAGE  0x00000001
#define TBNF_TEXT  0x00000002
#define TBNF_DI_SETITEM  0x10000000

#define TBDDRET_DEFAULT  0
#define TBDDRET_NODEFAULT  1
#define TBDDRET_TREATPRESSED  2

#define HICF_OTHER  0x00000000
#define HICF_MOUSE  0x00000001
#define HICF_ARROWKEYS  0x00000002
#define HICF_ACCELERATOR  0x00000004
#define HICF_DUPACCEL  0x00000008
#define HICF_ENTERING  0x00000010
#define HICF_LEAVING  0x00000020
#define HICF_RESELECT  0x00000040
#define HICF_LMOUSE  0x00000080
#define HICF_TOGGLEDROPDOWN  0x00000100

#define TB_ENABLEBUTTON  (WM_USER+1)
#define TB_CHECKBUTTON  (WM_USER+2)
#define TB_PRESSBUTTON  (WM_USER+3)
#define TB_HIDEBUTTON  (WM_USER+4)
#define TB_INDETERMINATE  (WM_USER+5)
#define TB_MARKBUTTON  (WM_USER+6)
#define TB_ISBUTTONENABLED  (WM_USER+9)
#define TB_ISBUTTONCHECKED  (WM_USER+10)
#define TB_ISBUTTONPRESSED  (WM_USER+11)
#define TB_ISBUTTONHIDDEN  (WM_USER+12)
#define TB_ISBUTTONINDETERMINATE  (WM_USER+13)
#define TB_ISBUTTONHIGHLIGHTED  (WM_USER+14)
#define TB_SETSTATE  (WM_USER+17)
#define TB_GETSTATE  (WM_USER+18)
#define TB_ADDBITMAP  (WM_USER+19)
#define TB_ADDBUTTONSA  (WM_USER+20)
#define TB_INSERTBUTTONA  (WM_USER+21)
#define TB_DELETEBUTTON  (WM_USER+22)
#define TB_GETBUTTON  (WM_USER+23)
#define TB_BUTTONCOUNT  (WM_USER+24)
#define TB_COMMANDTOINDEX  (WM_USER+25)
#define TB_SAVERESTOREA  (WM_USER+26)
#define TB_SAVERESTOREW  (WM_USER+76)
#define TB_CUSTOMIZE  (WM_USER+27)
#define TB_ADDSTRINGA  (WM_USER+28)
#define TB_ADDSTRINGW  (WM_USER+77)
#define TB_GETITEMRECT  (WM_USER+29)
#define TB_BUTTONSTRUCTSIZE  (WM_USER+30)
#define TB_SETBUTTONSIZE  (WM_USER+31)
#define TB_SETBITMAPSIZE  (WM_USER+32)
#define TB_AUTOSIZE  (WM_USER+33)
#define TB_GETTOOLTIPS  (WM_USER+35)

#ifdef WINCE
#define TB_SETTOOLTIPS  (WM_USER+81)
#else
#define TB_SETTOOLTIPS  (WM_USER+36)
#endif

#define TB_SETPARENT  (WM_USER+37)
#define TB_SETROWS  (WM_USER+39)
#define TB_GETROWS  (WM_USER+40)
#define TB_GETBITMAPFLAGS  (WM_USER+41)
#define TB_SETCMDID  (WM_USER+42)
#define TB_CHANGEBITMAP  (WM_USER+43)
#define TB_GETBITMAP  (WM_USER+44)
#define TB_GETBUTTONTEXTA  (WM_USER+45)
#define TB_GETBUTTONTEXTW  (WM_USER+75)
#define TB_REPLACEBITMAP  (WM_USER+46)
#define TB_SETINDENT  (WM_USER+47)
#define TB_SETIMAGELIST  (WM_USER+48)
#define TB_GETIMAGELIST  (WM_USER+49)
#define TB_LOADIMAGES  (WM_USER+50)
#define TB_GETRECT  (WM_USER+51)
#define TB_SETHOTIMAGELIST  (WM_USER+52)
#define TB_GETHOTIMAGELIST  (WM_USER+53)
#define TB_SETDISABLEDIMAGELIST  (WM_USER+54)
#define TB_GETDISABLEDIMAGELIST  (WM_USER+55)
#define TB_SETSTYLE  (WM_USER+56)
#define TB_GETSTYLE  (WM_USER+57)
#define TB_GETBUTTONSIZE  (WM_USER+58)
#define TB_SETBUTTONWIDTH  (WM_USER+59)
#define TB_SETMAXTEXTROWS  (WM_USER+60)
#define TB_GETTEXTROWS  (WM_USER+61)
#define TB_GETOBJECT  (WM_USER+62)
#define TB_GETBUTTONINFOW  (WM_USER+63)
#define TB_SETBUTTONINFOW  (WM_USER+64)
#define TB_GETBUTTONINFOA  (WM_USER+65)
#define TB_SETBUTTONINFOA  (WM_USER+66)
#define TB_INSERTBUTTONW  (WM_USER+67)
#define TB_ADDBUTTONSW  (WM_USER+68)
#define TB_HITTEST  (WM_USER+69)
#define TB_SETDRAWTEXTFLAGS  (WM_USER+70)
#define TB_GETHOTITEM  (WM_USER+71)
#define TB_SETHOTITEM  (WM_USER+72)
#define TB_SETANCHORHIGHLIGHT  (WM_USER+73)
#define TB_GETANCHORHIGHLIGHT  (WM_USER+74)
#define TB_MAPACCELERATORA  (WM_USER+78)
#define TB_GETINSERTMARK  (WM_USER+79)
#define TB_SETINSERTMARK  (WM_USER+80)
#define TB_INSERTMARKHITTEST  (WM_USER+81)
#define TB_MOVEBUTTON  (WM_USER+82)
#define TB_GETMAXSIZE  (WM_USER+83)
#define TB_SETEXTENDEDSTYLE  (WM_USER+84)
#define TB_GETEXTENDEDSTYLE  (WM_USER+85)
#define TB_GETPADDING  (WM_USER+86)
#define TB_SETPADDING  (WM_USER+87)
#define TB_SETINSERTMARKCOLOR  (WM_USER+88)
#define TB_GETINSERTMARKCOLOR  (WM_USER+89)
#define TB_SETCOLORSCHEME  CCM_SETCOLORSCHEME
#define TB_GETCOLORSCHEME  CCM_GETCOLORSCHEME
#define TB_SETUNICODEFORMAT  CCM_SETUNICODEFORMAT
#define TB_GETUNICODEFORMAT  CCM_GETUNICODEFORMAT
#define TB_MAPACCELERATORW  (WM_USER+90)
#define TB_GETSTRINGW  (WM_USER+91)
#define TB_GETSTRINGA  (WM_USER+92)
#define TB_GETMETRICS  (WM_USER+101)
#define TB_SETMETRICS  (WM_USER+102)
#define TB_SETPRESSEDIMAGELIST  (WM_USER + 104)
#define TB_GETPRESSEDIMAGELIST  (WM_USER + 105)

#define TB_SETWINDOWTHEME  CCM_SETWINDOWTHEME

#define TBN_GETBUTTONINFOA  (TBN_FIRST-0)
#define TBN_BEGINDRAG  (TBN_FIRST-1)
#define TBN_ENDDRAG  (TBN_FIRST-2)
#define TBN_BEGINADJUST  (TBN_FIRST-3)
#define TBN_ENDADJUST  (TBN_FIRST-4)
#define TBN_RESET  (TBN_FIRST-5)
#define TBN_QUERYINSERT  (TBN_FIRST-6)
#define TBN_QUERYDELETE  (TBN_FIRST-7)
#define TBN_TOOLBARCHANGE  (TBN_FIRST-8)
#define TBN_CUSTHELP  (TBN_FIRST-9)
#define TBN_DROPDOWN  (TBN_FIRST-10)
#define TBN_GETOBJECT  (TBN_FIRST-12)
#define TBN_HOTITEMCHANGE  (TBN_FIRST-13)
#define TBN_DRAGOUT  (TBN_FIRST-14)
#define TBN_DELETINGBUTTON  (TBN_FIRST-15)
#define TBN_GETDISPINFOA  (TBN_FIRST-16)
#define TBN_GETDISPINFOW  (TBN_FIRST-17)
#define TBN_GETINFOTIPA  (TBN_FIRST-18)
#define TBN_GETINFOTIPW  (TBN_FIRST-19)
#define TBN_GETBUTTONINFOW  (TBN_FIRST-20)
#define TBN_RESTORE  (TBN_FIRST-21)
#define TBN_SAVE  (TBN_FIRST-22)
#define TBN_INITCUSTOMIZE  (TBN_FIRST-23)
#define TBMF_PAD  0x00000001
#define TBMF_BARPAD  0x00000002
#define TBMF_BUTTONSPACING  0x00000004

#define IDB_STD_SMALL_COLOR  0
#define IDB_STD_LARGE_COLOR  1
#define IDB_VIEW_SMALL_COLOR  4
#define IDB_VIEW_LARGE_COLOR  5
#define IDB_HIST_SMALL_COLOR  8
#define IDB_HIST_LARGE_COLOR  9
#define IDB_HIST_NORMAL         12
#define IDB_HIST_HOT            13
#define IDB_HIST_DISABLED       14
#define IDB_HIST_PRESSED        15

#define STD_CUT  0
#define STD_COPY  1
#define STD_PASTE  2
#define STD_UNDO  3
#define STD_REDOW  4
#define STD_DELETE  5
#define STD_FILENEW  6
#define STD_FILEOPEN  7
#define STD_FILESAVE  8
#define STD_PRINTPRE  9
#define STD_PROPERTIES  10
#define STD_HELP  11
#define STD_FIND  12
#define STD_REPLACE  13
#define STD_PRINT  14

#define VIEW_LARGEICONS  0
#define VIEW_SMALLICONS  1
#define VIEW_LIST  2
#define VIEW_DETAILS  3
#define VIEW_SORTNAME  4
#define VIEW_SORTSIZE  5
#define VIEW_SORTDATE  6
#define VIEW_SORTTYPE  7
#define VIEW_PARENTFOLDER  8
#define VIEW_NETCONNECT  9
#define VIEW_NETDISCONNECT  10
#define VIEW_NEWFOLDER  11
#define VIEW_VIEWMENU  12

#define HIST_BACK  0
#define HIST_FORWARD  1
#define HIST_FAVORITES  2
#define HIST_ADDTOFAVORITES  3
#define HIST_VIEWTREE  4

#define TBNOTIFYA NMTOOLBARA
#define TBNOTIFYW NMTOOLBARW
#define TBNOTIFY NMTOOLBAR

TBBUTTON STRUCT
	iBitmap DD
	idCommand DD
	fsState DB
	fsStyle DB
#IFDEF WIN64
	bReserved DB 6 DUP
#ELSE
	bReserved DW
#ENDIF
	dwData DWORD_PTR
	iString INT_PTR
ENDS

COLORMAP STRUCT
	from DD
	to DD
ENDS

NMTBCUSTOMDRAW STRUCT
	nmcd NMCUSTOMDRAW
	hbrMonoDither HANDLE
	hbrLines HANDLE
	hpenLines HANDLE
	clrText DD
	clrMark DD
	clrTextHighlight DD
	clrBtnFace DD
	clrBtnHighlight DD
	clrHighlightHotTrack DD
	rcText RECT
	nStringBkMode DD
	nHLStringBkMode DD
	iListGap DD
ENDS

TBADDBITMAP STRUCT
	hInst HANDLE
	nID UINT_PTR
ENDS

TBSAVEPARAMSA STRUCT
	hkr HANDLE
	pszSubKey PTR
	pszValueName PTR
ENDS

#define TBSAVEPARAMSW TBSAVEPARAMSA

TBINSERTMARK STRUCT
	iButton DD
	dwFlags DD
ENDS

TBREPLACEBITMAP STRUCT
	hInstOld HANDLE
	nIDOld UINT_PTR
	hInstNew HANDLE
	nIDNew UINT_PTR
	nButtons DD
ENDS

TBBUTTONINFOA STRUCT
	cbSize DD
	dwMask DD
	idCommand DD
	iImage DD
	fsState DB
	fsStyle DB
	cx DW
	lParam DD
	pszText PTR
	cchText DD
#IFDEF VISTA
	iImageLabel DD
#ENDIF
ENDS

#define TBBUTTONINFOW TBBUTTONINFOA

NMTBSAVE STRUCT
	hdr NMHDR
	pData PTR
	pCurrent PTR
	cbData DD
	iItem DD
	cButtons DD
	tbButton TBBUTTON
ENDS

NMTBRESTORE STRUCT
	hdr NMHDR
	pData PTR
	pCurrent PTR
	cbData DD
	iItem DD
	cButtons DD
	cbBytesPerRecord DD
	tbButton TBBUTTON
ENDS

NMTBHOTITEM STRUCT
	hdr NMHDR
	idOld DD
	idNew DD
	dwFlags DD
ENDS

NMTBGETINFOTIPA STRUCT
	hdr NMHDR
	pszText PTR
	cchTextMax DD
	iItem DD
	lParam LPARAM
ENDS

#define NMTBGETINFOTIPW NMTBGETINFOTIPA

NMTBDISPINFOA STRUCT
	hdr NMHDR
	dwMask DD
	idCommand DD
	lParam DWORD_PTR
	iImage DD
	pszText PTR
	cchText DD
ENDS

#define NMTBDISPINFOW NMTBDISPINFOA

NMTOOLBARA STRUCT
	hdr NMHDR
	iItem DD
	tbButton TBBUTTON
	cchText DD
	pszText PTR
	rcButton RECT
ENDS

#define NMTOOLBARW NMTOOLBARA

TBMETRICS STRUCT
	cbSize DD
	dwMask DD
	cxPad DD
	cyPad DD
	cxBarPad DD
	cyBarPad DD
	cxButtonSpacing DD
	cyButtonSpacing DD
ENDS

#IFDEF UNICODE
	#define TOOLBARCLASSNAME  TOOLBARCLASSNAMEW
	#define TBSAVEPARAMS TBSAVEPARAMSW
	#define TBBUTTONINFO TBBUTTONINFOW
	#define NMTBGETINFOTIP NMTBGETINFOTIPW
	#define NMTBDISPINFO NMTBDISPINFOW
	#define NMTOOLBAR NMTOOLBARW
	#define TB_GETBUTTONTEXT TB_GETBUTTONTEXTW
	#define TB_SAVERESTORE TB_SAVERESTOREW
	#define TB_ADDSTRING TB_ADDSTRINGW
	#define TB_GETBUTTONINFO TB_GETBUTTONINFOW
	#define TB_SETBUTTONINFO TB_SETBUTTONINFOW
	#define TB_INSERTBUTTON TB_INSERTBUTTONW
	#define TB_ADDBUTTONS TB_ADDBUTTONSW
	#define TB_MAPACCELERATOR TB_MAPACCELERATORW
	#define TB_GETSTRING TB_GETSTRINGW
	#define TBN_GETINFOTIP TBN_GETINFOTIPW
	#define TBN_GETDISPINFO TBN_GETDISPINFOW
	#define TBN_GETBUTTONINFO TBN_GETBUTTONINFOW
#else
	#define TOOLBARCLASSNAME  TOOLBARCLASSNAMEA
	#define TBSAVEPARAMS TBSAVEPARAMSA
	#define TBBUTTONINFO TBBUTTONINFOA
	#define NMTBGETINFOTIP NMTBGETINFOTIPA
	#define NMTBDISPINFO NMTBDISPINFOA
	#define NMTOOLBAR NMTOOLBARA
	#define TB_GETBUTTONTEXT TB_GETBUTTONTEXTA
	#define TB_SAVERESTORE TB_SAVERESTOREA
	#define TB_ADDSTRING TB_ADDSTRINGA
	#define TB_GETBUTTONINFO TB_GETBUTTONINFOA
	#define TB_SETBUTTONINFO TB_SETBUTTONINFOA
	#define TB_INSERTBUTTON TB_INSERTBUTTONA
	#define TB_ADDBUTTONS TB_ADDBUTTONSA
	#define TB_MAPACCELERATOR TB_MAPACCELERATORA
	#define TB_GETSTRING TB_GETSTRINGA
	#define TBN_GETINFOTIP TBN_GETINFOTIPA
	#define TBN_GETDISPINFO TBN_GETDISPINFOA
	#define TBN_GETBUTTONINFO TBN_GETBUTTONINFOA
#endif

/* ReBar Control ************************************************************/

#define REBARCLASSNAMEW  L"ReBarWindow32"
#define REBARCLASSNAMEA  A"ReBarWindow32"

#define RBIM_IMAGELIST  0x00000001

#ifdef WINCE
#define RBS_SMARTLABELS  0x1000
#else
#define RBS_REGISTERDROP  0x1000
#endif

#define RBS_AUTOSIZE  0x2000
#define RBS_VERTICALGRIPPER 0x4000
#define RBS_DBLCLKTOGGLE  0x8000
#define RBS_TOOLTIPS  0x0100
#define RBS_VARHEIGHT  0x0200
#define RBS_BANDBORDERS  0x0400
#define RBS_FIXEDORDER  0x0800

#define RBBS_BREAK  0x00000001
#define RBBS_FIXEDSIZE  0x00000002
#define RBBS_CHILDEDGE  0x00000004
#define RBBS_HIDDEN  0x00000008
#define RBBS_NOVERT  0x00000010
#define RBBS_FIXEDBMP  0x00000020
#define RBBS_VARIABLEHEIGHT 0x00000040
#define RBBS_GRIPPERALWAYS  0x00000080

#define RBBS_NOGRIPPER  0x00000100

#define RBBS_USECHEVRON  0x00000200
#define RBBS_HIDETITLE  0x00000400
#define RBBS_TOPALIGN  0x00000800

#define RBBIM_STYLE  0x00000001
#define RBBIM_COLORS  0x00000002
#define RBBIM_TEXT  0x00000004
#define RBBIM_IMAGE  0x00000008
#define RBBIM_CHILD  0x00000010
#define RBBIM_CHILDSIZE  0x00000020
#define RBBIM_SIZE  0x00000040
#define RBBIM_BACKGROUND  0x00000080
#define RBBIM_ID  0x00000100
#define RBBIM_IDEALSIZE  0x00000200
#define RBBIM_LPARAM  0x00000400
#define RBBIM_HEADERSIZE  0x00000800
#define RBBIM_CHEVRONLOCATION 0x00001000
#define RBBIM_CHEVRONSTATE    0x00002000

#define RBNM_ID  0x00000001
#define RBNM_STYLE  0x00000002
#define RBNM_LPARAM  0x00000004

#define RBHT_NOWHERE  0x0001
#define RBHT_CAPTION  0x0002
#define RBHT_CLIENT  0x0003
#define RBHT_GRABBER  0x0004
#define RBHT_CHEVRON  0x0008
#define RBHT_SPLITTER   0x0010

#define RBSTR_CHANGERECT  0x0001

#define RBAB_AUTOSIZE  0x0001
#define RBAB_ADDBAND  0x0002

#define RB_INSERTBANDA  (WM_USER+1)
#define RB_DELETEBAND  (WM_USER+2)
#define RB_GETBARINFO  (WM_USER+3)
#define RB_SETBARINFO  (WM_USER+4)
;#define RB_GETBANDINFO  (WM_USER+5)
#define RB_SETBANDINFOA  (WM_USER+6)
#define RB_SETPARENT  (WM_USER+7)
#define RB_HITTEST  (WM_USER+8)
#define RB_GETRECT  (WM_USER+9)
#define RB_INSERTBANDW  (WM_USER+10)
#define RB_SETBANDINFOW  (WM_USER+11)
#define RB_GETBANDCOUNT  (WM_USER+12)
#define RB_GETROWCOUNT  (WM_USER+13)
#define RB_GETROWHEIGHT  (WM_USER+14)
#define RB_IDTOINDEX  (WM_USER+16)
#define RB_GETTOOLTIPS  (WM_USER+17)
#define RB_SETTOOLTIPS  (WM_USER+18)
#define RB_SETBKCOLOR  (WM_USER+19)
#define RB_GETBKCOLOR  (WM_USER+20)
#define RB_SETTEXTCOLOR  (WM_USER+21)
#define RB_GETTEXTCOLOR  (WM_USER+22)
#define RB_SIZETORECT  (WM_USER+23)
#define RB_SETCOLORSCHEME  CCM_SETCOLORSCHEME
#define RB_GETCOLORSCHEME  CCM_GETCOLORSCHEME

#define RB_BEGINDRAG  (WM_USER+24)
#define RB_ENDDRAG  (WM_USER+25)
#define RB_DRAGMOVE  (WM_USER+26)
#define RB_GETBARHEIGHT  (WM_USER+27)
#define RB_GETBANDINFOW  (WM_USER+28)
#define RB_GETBANDINFOA  (WM_USER+29)
#define RB_MINIMIZEBAND  (WM_USER+30)
#define RB_MAXIMIZEBAND  (WM_USER+31)
#define RB_GETDROPTARGET  CCM_GETDROPTARGET
#define RB_GETBANDBORDERS  (WM_USER+34)
#define RB_SHOWBAND  (WM_USER+35)
#define RB_SETPALETTE  (WM_USER+37)
#define RB_GETPALETTE  (WM_USER+38)
#define RB_MOVEBAND  (WM_USER+39)
#define RB_SETUNICODEFORMAT CCM_SETUNICODEFORMAT
#define RB_GETUNICODEFORMAT CCM_GETUNICODEFORMAT
#define RB_GETBANDMARGINS  (WM_USER+40)
#define RB_SETEXTENDEDSTYLE (WM_USER + 41)
#define RB_GETEXTENDEDSTYLE (WM_USER + 42)
#define RB_PUSHCHEVRON  (WM_USER+43)
#define RB_SETBANDWIDTH     (WM_USER + 44)
#define RB_SETWINDOWTHEME  CCM_SETWINDOWTHEME

#define RBN_HEIGHTCHANGE  (RBN_FIRST-0)
#define RBN_GETOBJECT  (RBN_FIRST-1)
#define RBN_LAYOUTCHANGED  (RBN_FIRST-2)
#define RBN_AUTOSIZE  (RBN_FIRST-3)
#define RBN_BEGINDRAG  (RBN_FIRST-4)
#define RBN_ENDDRAG  (RBN_FIRST-5)
#define RBN_DELETINGBAND  (RBN_FIRST-6)
#define RBN_DELETEDBAND  (RBN_FIRST-7)
#define RBN_CHILDSIZE  (RBN_FIRST-8)
#define RBN_CHEVRONPUSHED  (RBN_FIRST-10)
#define RBN_SPLITTERDRAG    (RBN_FIRST - 11)
#define RBN_MINMAX  (RBN_FIRST-21)
#define RBN_AUTOBREAK  (RBN_FIRST-22)

REBARINFO STRUCT
	cbSize DD
	fMask DD
	himl HANDLE
ENDS

REBARBANDINFOA STRUCT
	cbSize DD
	fMask DD
	fStyle DD
	clrFore DD
	clrBack DD
	lpText PTR
	cch DD
	iImage DD
	hwndChild DD
	cxMinChild DD
	cyMinChild DD
	cx DD
	hbmBack DD
	wID DD
	cyChild DD
	cyMaxChild DD
	cyIntegral DD
	cxIdeal DD
	lParam LPARAM
	cxHeader DD
#IFDEF VISTA
	rcChevronLocation RECT
	uChevronState DD
#ENDIF
ENDS

#define REBARBANDINFOW REBARBANDINFOA

NMREBARCHILDSIZE STRUCT
	hdr NMHDR
	uBand DD
	wID DD
	rcChild RECT
	rcBand RECT
ENDS

NMREBAR STRUCT
	hdr NMHDR
	dwMask DD
	uBand DD
	fStyle DD
	wID DD
	lParam LPARAM
ENDS

NMRBAUTOSIZE STRUCT
	hdr NMHDR
	fChanged DD
	rcTarget RECT
	rcActual RECT
ENDS

NMREBARCHEVRON STRUCT
	hdr NMHDR
	uBand DD
	wID DD
	lParam LPARAM
	rc RECT
	lParamNM DD
ENDS

RB_HITTESTINFO STRUCT
	pt POINT
	flags DD
	iBand DD
ENDS

NMREBARAUTOBREAK STRUCT
	hdr NMHDR
	uBand DD
	wID DD
	lParam LPARAM
	uMsg DD
	fStyleCurrent DD
	fAutoBreak DD
ENDS

NMREBARSPLITTER STRUCT
	hdr NMHDR
	rcSizing RECT
ENDS

#IFDEF UNICODE
	#define REBARCLASSNAME REBARCLASSNAMEW
	#define REBARBANDINFO REBARBANDINFOW
	#define REBARBANDINFO_V3_SIZE REBARBANDINFOW_V3_SIZE
	#define RB_INSERTBAND RB_INSERTBANDW
	#define RB_SETBANDINFO RB_SETBANDINFOW
	#define RB_GETBANDINFO RB_GETBANDINFOW
#else
	#define REBARCLASSNAME  REBARCLASSNAMEA
	#define REBARBANDINFO REBARBANDINFOA
	#define REBARBANDINFO_V3_SIZE REBARBANDINFOA_V3_SIZE
	#define RB_INSERTBAND RB_INSERTBANDA
	#define RB_SETBANDINFO RB_SETBANDINFOA
	#define RB_GETBANDINFO RB_GETBANDINFOA
#endif


/* CommandBar Control *******************************************************/

#ifdef WINCE

COMMANDBANDSRESTOREINFO STRUCT
	cbSize DD
	wID DD
	fStyle DD
	cxRestored DD
	fMaximized DD
ENDS

#define CMDBAR_HELP  0x000B
#define CMDBAR_OK  0xF000

#endif

/* Tooltips Control *********************************************************/

#define TOOLTIPS_CLASSW  L"tooltips_class32"
#define TOOLTIPS_CLASSA  A"tooltips_class32"

#define TTS_ALWAYSTIP  0x01
#define TTS_NOPREFIX  0x02
#define TTS_NOANIMATE  0x10
#define TTS_NOFADE  0x20
#define TTS_BALLOON  0x40
#define TTS_CLOSE 0x80
#define TTS_USEVISUALSTYLE 0x100

#define TTF_IDISHWND  0x0001

#define TTF_CENTERTIP  0x0002
#define TTF_RTLREADING  0x0004
#define TTF_SUBCLASS  0x0010
#define TTF_TRACK  0x0020
#define TTF_ABSOLUTE  0x0080
#define TTF_TRANSPARENT  0x0100
#define TTF_PARSELINKS  0x1000
#define TTF_DI_SETITEM  0x8000

#define TTDT_AUTOMATIC  0
#define TTDT_RESHOW  1
#define TTDT_AUTOPOP  2
#define TTDT_INITIAL  3

#define TTI_NONE  0
#define TTI_INFO  1
#define TTI_WARNING  2
#define TTI_ERROR  3
#define TTI_INFO_LARGE 4
#define TTI_WARNING_LARGE 5
#define TTI_ERROR_LARGE 6

#define TTM_ACTIVATE  (WM_USER+1)
#define TTM_SETDELAYTIME  (WM_USER+3)
#define TTM_ADDTOOLA  (WM_USER+4)
#define TTM_ADDTOOLW  (WM_USER+50)
#define TTM_DELTOOLA  (WM_USER+5)
#define TTM_DELTOOLW  (WM_USER+51)
#define TTM_NEWTOOLRECTA  (WM_USER+6)
#define TTM_NEWTOOLRECTW  (WM_USER+52)
#define TTM_RELAYEVENT  (WM_USER+7)
#define TTM_GETTOOLINFOA  (WM_USER+8)
#define TTM_GETTOOLINFOW  (WM_USER+53)
#define TTM_SETTOOLINFOA  (WM_USER+9)
#define TTM_SETTOOLINFOW  (WM_USER+54)
#define TTM_HITTESTA  (WM_USER+10)
#define TTM_HITTESTW  (WM_USER+55)
#define TTM_GETTEXTA  (WM_USER+11)
#define TTM_GETTEXTW  (WM_USER+56)
#define TTM_UPDATETIPTEXTA  (WM_USER+12)
#define TTM_UPDATETIPTEXTW  (WM_USER+57)
#define TTM_GETTOOLCOUNT  (WM_USER+13)
#define TTM_ENUMTOOLSA  (WM_USER+14)
#define TTM_ENUMTOOLSW  (WM_USER+58)
#define TTM_GETCURRENTTOOLA  (WM_USER+15)
#define TTM_GETCURRENTTOOLW  (WM_USER+59)
#define TTM_WINDOWFROMPOINT  (WM_USER+16)
#define TTM_TRACKACTIVATE  (WM_USER+17)
#define TTM_TRACKPOSITION  (WM_USER+18)
#define TTM_SETTIPBKCOLOR  (WM_USER+19)
#define TTM_SETTIPTEXTCOLOR  (WM_USER+20)
#define TTM_GETDELAYTIME  (WM_USER+21)
#define TTM_GETTIPBKCOLOR  (WM_USER+22)
#define TTM_GETTIPTEXTCOLOR  (WM_USER+23)
#define TTM_SETMAXTIPWIDTH  (WM_USER+24)
#define TTM_GETMAXTIPWIDTH  (WM_USER+25)
#define TTM_SETMARGIN  (WM_USER+26)
#define TTM_GETMARGIN  (WM_USER+27)
#define TTM_POP  (WM_USER+28)
#define TTM_UPDATE  (WM_USER+29)
#define TTM_GETBUBBLESIZE  (WM_USER+30)
#define TTM_ADJUSTRECT  (WM_USER+31)
#define TTM_SETTITLEA  (WM_USER+32)
#define TTM_SETTITLEW  (WM_USER+33)
#define TTM_POPUP  (WM_USER+34)
#define TTM_GETTITLE  (WM_USER+35)
#define TTM_SETWINDOWTHEME  CCM_SETWINDOWTHEME

#define TTN_GETDISPINFOA  (TTN_FIRST-0)
#define TTN_GETDISPINFOW  (TTN_FIRST-10)
#define TTN_SHOW  (TTN_FIRST-1)
#define TTN_POP  (TTN_FIRST-2)
#define TTN_LINKCLICK (TTN_FIRST - 3)
#define TTN_NEEDTEXT  TTN_GETDISPINFO
#define TTN_NEEDTEXTA  TTN_GETDISPINFOA
#define TTN_NEEDTEXTW  TTN_GETDISPINFOW

#define TOOLTIPTEXTW NMTTDISPINFOW
#define TOOLTIPTEXTA NMTTDISPINFOA
#define TOOLTIPTEXT NMTTDISPINFO

TOOLINFOA STRUCT
	cbSize DD
	uFlags DD
	hwnd HANDLE
	uId UINT_PTR
	rect RECT
	hInst DD
	lpszText PTR
	lParam LPARAM
#IFNDEF WIN9X
	lpReserved PTR
#ENDIF
ENDS

#define TOOLINFOW TOOLINFOA

TT_HITTESTINFOA STRUCT
	hwnd HANDLE
	pt POINT
	ti TOOLINFOA
ENDS

TT_HITTESTINFOW STRUCT
	hwnd HANDLE
	pt POINT
	ti TOOLINFOW
ENDS

NMTTDISPINFOA STRUCT
	hdr NMHDR
	lpszText PTR
	szText DB 80 DUP
	UNION
		hinst HANDLE
		hInst HANDLE
	ENDUNION
	uFlags DD
	lParam LPARAM
#IFDEF VISTA
	hbmp HANDLE
#ENDIF
ENDS

NMTTDISPINFOW STRUCT
	hdr NMHDR
	lpszText PTR
	szText DW 80 DUP
	UNION
		hinst HANDLE
		hInst HANDLE
	ENDUNION
	uFlags DD
	lParam LPARAM
#IFDEF VISTA
	hbmp HANDLE
#ENDIF
ENDS

TTGETTITLE STRUCT
	dwSize DD
	uTitleBitmap DD
	cch DD
	pszTitle PTR
ENDS

#IFDEF UNICODE
	#define TOOLTIPS_CLASS  TOOLTIPS_CLASSW
	#define TOOLINFO TOOLINFOW
	#define TOOLINFO_V1_SIZE TOOLINFOW_V1_SIZE
	#define TTHITTESTINFO TTHITTESTINFOW
	#define NMTTDISPINFO NMTTDISPINFOW
	#define NMTTDISPINFO_V1_SIZE NMTTDISPINFOW_V1_SIZE
	#define TTM_ADDTOOL TTM_ADDTOOLW
	#define TTM_DELTOOL TTM_DELTOOLW
	#define TTM_NEWTOOLRECT TTM_NEWTOOLRECTW
	#define TTM_GETTOOLINFO TTM_GETTOOLINFOW
	#define TTM_SETTOOLINFO TTM_SETTOOLINFOW
	#define TTM_HITTEST TTM_HITTESTW
	#define TTM_GETTEXT TTM_GETTEXTW
	#define TTM_UPDATETIPTEXT TTM_UPDATETIPTEXTW
	#define TTM_ENUMTOOLS TTM_ENUMTOOLSW
	#define TTM_GETCURRENTTOOL TTM_GETCURRENTTOOLW
	#define TTM_SETTITLE TTM_SETTITLEW
	#define TTN_GETDISPINFO TTN_GETDISPINFOW
#else
	#define TOOLTIPS_CLASS  TOOLTIPS_CLASSA
	#define TOOLINFO TOOLINFOA
	#define TOOLINFO_V1_SIZE TOOLINFOA_V1_SIZE
	#define TTHITTESTINFO TTHITTESTINFOA
	#define NMTTDISPINFO NMTTDISPINFOA
	#define NMTTDISPINFO_V1_SIZE NMTTDISPINFOA_V1_SIZE
	#define TTM_ADDTOOL TTM_ADDTOOLA
	#define TTM_DELTOOL TTM_DELTOOLA
	#define TTM_NEWTOOLRECT TTM_NEWTOOLRECTA
	#define TTM_GETTOOLINFO TTM_GETTOOLINFOA
	#define TTM_SETTOOLINFO TTM_SETTOOLINFOA
	#define TTM_HITTEST TTM_HITTESTA
	#define TTM_GETTEXT TTM_GETTEXTA
	#define TTM_UPDATETIPTEXT TTM_UPDATETIPTEXTA
	#define TTM_ENUMTOOLS TTM_ENUMTOOLSA
	#define TTM_GETCURRENTTOOL TTM_GETCURRENTTOOLA
	#define TTM_SETTITLE TTM_SETTITLEA
	#define TTN_GETDISPINFO TTN_GETDISPINFOA
#endif

/* Status bar Control *******************************************************/

#define STATUSCLASSNAMEW  L"msctls_statusbar32"
#define STATUSCLASSNAMEA  A"msctls_statusbar32"

#define SBARS_SIZEGRIP  0x0100
#define SBARS_TOOLTIPS  0x0800

#define SBT_TOOLTIPS  0x0800

#define SB_SETTEXTA  (WM_USER+1)
#define SB_SETTEXTW  (WM_USER+11)
#define SB_GETTEXTA  (WM_USER+2)
#define SB_GETTEXTW  (WM_USER+13)
#define SB_GETTEXTLENGTHA  (WM_USER+3)
#define SB_GETTEXTLENGTHW  (WM_USER+12)
#define SB_SETPARTS  (WM_USER+4)
#define SB_GETPARTS  (WM_USER+6)
#define SB_GETBORDERS  (WM_USER+7)
#define SB_SETMINHEIGHT  (WM_USER+8)
#define SB_SIMPLE  (WM_USER+9)
#define SB_GETRECT  (WM_USER+10)
#define SB_ISSIMPLE  (WM_USER+14)
#define SB_SETICON  (WM_USER+15)
#define SB_SETTIPTEXTA  (WM_USER+16)
#define SB_SETTIPTEXTW  (WM_USER+17)
#define SB_GETTIPTEXTA  (WM_USER+18)
#define SB_GETTIPTEXTW  (WM_USER+19)
#define SB_GETICON  (WM_USER+20)
#define SB_SETUNICODEFORMAT  CCM_SETUNICODEFORMAT
#define SB_GETUNICODEFORMAT  CCM_GETUNICODEFORMAT
#define SB_SETBKCOLOR  CCM_SETBKCOLOR

#define SBT_OWNERDRAW  0x1000
#define SBT_NOBORDERS  0x0100
#define SBT_POPOUT  0x0200
#define SBT_RTLREADING  0x0400
#define SBT_NOTABPARSING  0x0800

#define SBN_SIMPLEMODECHANGE  (SBN_FIRST-0)

#define SB_SIMPLEID  0x00ff

#IFDEF UNICODE
	#define STATUSCLASSNAME  STATUSCLASSNAMEW
	#define CreateStatusWindow CreateStatusWindowW
	#define DrawStatusText DrawStatusTextW
	#define SB_GETTEXT SB_GETTEXTW
	#define SB_SETTEXT SB_SETTEXTW
	#define SB_GETTEXTLENGTH SB_GETTEXTLENGTHW
	#define SB_SETTIPTEXT SB_SETTIPTEXTW
	#define SB_GETTIPTEXT SB_GETTIPTEXTW
#else
	#define STATUSCLASSNAME  STATUSCLASSNAMEA
	#define CreateStatusWindow CreateStatusWindowA
	#define DrawStatusText DrawStatusTextA
	#define SB_GETTEXT SB_GETTEXTA
	#define SB_SETTEXT SB_SETTEXTA
	#define SB_GETTEXTLENGTH SB_GETTEXTLENGTHA
	#define SB_SETTIPTEXT SB_SETTIPTEXTA
	#define SB_GETTIPTEXT SB_GETTIPTEXTA
#endif

/* Meny help ****************************************************************/

#define MINSYSCOMMAND  SC_SIZE

/* Trackbar Control *********************************************************/

#define TRACKBAR_CLASSA  A"msctls_trackbar32"
#define TRACKBAR_CLASSW  L"msctls_trackbar32"

#define TBS_AUTOTICKS  0x0001
#define TBS_VERT  0x0002
#define TBS_HORZ  0x0000
#define TBS_TOP  0x0004
#define TBS_BOTTOM  0x0000
#define TBS_LEFT  0x0004
#define TBS_RIGHT  0x0000
#define TBS_BOTH  0x0008
#define TBS_NOTICKS  0x0010
#define TBS_ENABLESELRANGE  0x0020
#define TBS_FIXEDLENGTH  0x0040
#define TBS_NOTHUMB  0x0080
#define TBS_TOOLTIPS  0x0100
#define TBS_REVERSED  0x0200
#define TBS_DOWNISLEFT  0x0400
#define TBS_NOTIFYBEFOREMOVE    0x0800
#define TBS_TRANSPARENTBKGND    0x1000

#define TBM_GETPOS  (WM_USER)
#define TBM_GETRANGEMIN  (WM_USER+1)
#define TBM_GETRANGEMAX  (WM_USER+2)
#define TBM_GETTIC  (WM_USER+3)
#define TBM_SETTIC  (WM_USER+4)
#define TBM_SETPOS  (WM_USER+5)
#define TBM_SETRANGE  (WM_USER+6)
#define TBM_SETRANGEMIN  (WM_USER+7)
#define TBM_SETRANGEMAX  (WM_USER+8)
#define TBM_CLEARTICS  (WM_USER+9)
#define TBM_SETSEL  (WM_USER+10)
#define TBM_SETSELSTART  (WM_USER+11)
#define TBM_SETSELEND  (WM_USER+12)
#define TBM_GETPTICS  (WM_USER+14)
#define TBM_GETTICPOS  (WM_USER+15)
#define TBM_GETNUMTICS  (WM_USER+16)
#define TBM_GETSELSTART  (WM_USER+17)
#define TBM_GETSELEND  (WM_USER+18)
#define TBM_CLEARSEL  (WM_USER+19)
#define TBM_SETTICFREQ  (WM_USER+20)
#define TBM_SETPAGESIZE  (WM_USER+21)
#define TBM_GETPAGESIZE  (WM_USER+22)
#define TBM_SETLINESIZE  (WM_USER+23)
#define TBM_GETLINESIZE  (WM_USER+24)
#define TBM_GETTHUMBRECT  (WM_USER+25)
#define TBM_GETCHANNELRECT  (WM_USER+26)
#define TBM_SETTHUMBLENGTH  (WM_USER+27)
#define TBM_GETTHUMBLENGTH  (WM_USER+28)
#define TBM_SETTOOLTIPS  (WM_USER+29)
#define TBM_GETTOOLTIPS  (WM_USER+30)
#define TBM_SETTIPSIDE  (WM_USER+31)
#define TBM_SETBUDDY  (WM_USER+32)
#define TBM_GETBUDDY  (WM_USER+33)
#define TBM_SETUNICODEFORMAT  CCM_SETUNICODEFORMAT
#define TBM_GETUNICODEFORMAT  CCM_GETUNICODEFORMAT

#define TBTS_TOP  0
#define TBTS_LEFT  1
#define TBTS_BOTTOM  2
#define TBTS_RIGHT  3

#define TB_LINEUP  0
#define TB_LINEDOWN  1
#define TB_PAGEUP  2
#define TB_PAGEDOWN  3
#define TB_THUMBPOSITION  4
#define TB_THUMBTRACK  5
#define TB_TOP  6
#define TB_BOTTOM  7
#define TB_ENDTRACK  8

#define TBCD_TICS  0x0001
#define TBCD_THUMB  0x0002
#define TBCD_CHANNEL  0x0003

#define TRBN_THUMBPOSCHANGING (TRBN_FIRST-1)

NMTRBTHUMBPOSCHANGING STRUCT
	hdr NMHDR
	dwPos DD
	nReason DD
ENDS

#IFDEF UNICODE
	#define TRACKBAR_CLASS  TRACKBAR_CLASSW
#else
	#define TRACKBAR_CLASS  TRACKBAR_CLASSA
#endif

/* Drag list Control ********************************************************/

#define DRAGLISTMSGSTRING "commctrl_DragListMsg"

#define DL_BEGINDRAG  (WM_USER+133)
#define DL_DRAGGING  (WM_USER+134)
#define DL_DROPPED  (WM_USER+135)
#define DL_CANCELDRAG  (WM_USER+136)

#define DL_CURSORSET  0
#define DL_STOPCURSOR  1
#define DL_COPYCURSOR  2
#define DL_MOVECURSOR  3

DRAGLISTINFO STRUCT
	uNotification DD
	UNION
		hwnd HANDLE
		hWnd HANDLE
	ENDUNION
	ptCursor POINT
ENDS

/* UpDown Control ***********************************************************/

#define UPDOWN_CLASSA  A"msctls_updown32"
#define UPDOWN_CLASSW  L"msctls_updown32"

#define UD_MAXVAL  0x7fff
#define UD_MINVAL  (-UD_MAXVAL)

#define UDS_WRAP  0x0001
#define UDS_SETBUDDYINT  0x0002
#define UDS_ALIGNRIGHT  0x0004
#define UDS_ALIGNLEFT  0x0008
#define UDS_AUTOBUDDY  0x0010
#define UDS_ARROWKEYS  0x0020
#define UDS_HORZ  0x0040
#define UDS_NOTHOUSANDS  0x0080
#define UDS_HOTTRACK  0x0100

#define UDM_SETRANGE  (WM_USER+101)
#define UDM_GETRANGE  (WM_USER+102)
#define UDM_SETPOS  (WM_USER+103)
#define UDM_GETPOS  (WM_USER+104)
#define UDM_SETBUDDY  (WM_USER+105)
#define UDM_GETBUDDY  (WM_USER+106)
#define UDM_SETACCEL  (WM_USER+107)
#define UDM_GETACCEL  (WM_USER+108)
#define UDM_SETBASE  (WM_USER+109)
#define UDM_GETBASE  (WM_USER+110)
#define UDM_SETRANGE32  (WM_USER+111)
#define UDM_GETRANGE32  (WM_USER+112)
#define UDM_SETUNICODEFORMAT  CCM_SETUNICODEFORMAT
#define UDM_GETUNICODEFORMAT  CCM_GETUNICODEFORMAT
#define UDM_SETPOS32  (WM_USER+113)
#define UDM_GETPOS32  (WM_USER+114)

#define UDN_DELTAPOS  (UDN_FIRST-1)

#define NM_UPDOWN NMUPDOWN

UDACCEL STRUCT
	nSec DD
	nInc DD
ENDS

NMUPDOWN STRUCT
	hdr NMHDR
	iPos DD
	iDelta DD
ENDS

#IFDEF UNICODE
	#define UPDOWN_CLASS  UPDOWN_CLASSW
#else
	#define UPDOWN_CLASS  UPDOWN_CLASSA
#endif

/* Progress Control *********************************************************/

#define PROGRESS_CLASSA  A"msctls_progress32"
#define PROGRESS_CLASSW  L"msctls_progress32"

#define PBS_SMOOTH  0x01
#define PBS_VERTICAL  0x04
#define PBS_MARQUEE  0x08
#define PBS_SMOOTHREVERSE 0x10

#define PBST_NORMAL 0x0001
#define PBST_ERROR 0x0002
#define PBST_PAUSED 0x0003

#define PBM_SETRANGE  (WM_USER+1)
#define PBM_SETPOS  (WM_USER+2)
#define PBM_DELTAPOS  (WM_USER+3)
#define PBM_SETSTEP  (WM_USER+4)
#define PBM_STEPIT  (WM_USER+5)
#define PBM_SETRANGE32  (WM_USER+6)
#define PBM_GETRANGE  (WM_USER+7)
#define PBM_GETPOS  (WM_USER+8)
#define PBM_SETBARCOLOR  (WM_USER+9)
#define PBM_SETBKCOLOR  CCM_SETBKCOLOR
#define PBM_SETMARQUEE  (WM_USER+10)
#define PBM_GETSTEP (WM_USER+13)
#define PBM_GETBKCOLOR (WM_USER+14)
#define PBM_GETBARCOLOR (WM_USER+15)
#define PBM_SETSTATE (WM_USER+16)
#define PBM_GETSTATE (WM_USER+17)

PBRANGE STRUCT
	iLow DD
	iHigh DD
ENDS

#IFDEF UNICODE
	#define  PROGRESS_CLASS  PROGRESS_CLASSW
#else
	#define  PROGRESS_CLASS  PROGRESS_CLASSA
#endif

/* HotKey Control ***********************************************************/

#define HOTKEY_CLASSA  A"msctls_hotkey32"
#define HOTKEY_CLASSW  L"msctls_hotkey32"

#define HOTKEYF_SHIFT  0x01
#define HOTKEYF_CONTROL  0x02
#define HOTKEYF_ALT  0x04
#define HOTKEYF_EXT  0x08

#define HKCOMB_NONE  0x0001
#define HKCOMB_S  0x0002
#define HKCOMB_C  0x0004
#define HKCOMB_A  0x0008
#define HKCOMB_SC  0x0010
#define HKCOMB_SA  0x0020
#define HKCOMB_CA  0x0040
#define HKCOMB_SCA  0x0080

#define HKM_SETHOTKEY  (WM_USER+1)
#define HKM_GETHOTKEY  (WM_USER+2)
#define HKM_SETRULES  (WM_USER+3)

#IFDEF UNICODE
	#define HOTKEY_CLASS  HOTKEY_CLASSW
#else
	#define HOTKEY_CLASS  HOTKEY_CLASSA
#endif

/* ListView Control *********************************************************/

#define WC_LISTVIEWA  A"SysListView32"
#define WC_LISTVIEWW  L"SysListView32"

#define LVS_ICON  0x0000
#define LVS_REPORT  0x0001
#define LVS_SMALLICON  0x0002
#define LVS_LIST  0x0003
#define LVS_TYPEMASK  0x0003
#define LVS_SINGLESEL  0x0004
#define LVS_SHOWSELALWAYS  0x0008
#define LVS_SORTASCENDING  0x0010
#define LVS_SORTDESCENDING  0x0020
#define LVS_SHAREIMAGELISTS  0x0040
#define LVS_NOLABELWRAP  0x0080
#define LVS_AUTOARRANGE  0x0100
#define LVS_EDITLABELS  0x0200
#define LVS_OWNERDATA  0x1000
#define LVS_NOSCROLL  0x2000
#define LVS_TYPESTYLEMASK  0xfc00
#define LVS_ALIGNTOP  0x0000
#define LVS_ALIGNLEFT  0x0800
#define LVS_ALIGNMASK  0x0c00
#define LVS_OWNERDRAWFIXED  0x0400
#define LVS_NOCOLUMNHEADER  0x4000
#define LVS_NOSORTHEADER  0x8000

#define LVS_EX_GRIDLINES  0x00000001
#define LVS_EX_SUBITEMIMAGES  0x00000002
#define LVS_EX_CHECKBOXES  0x00000004
#define LVS_EX_TRACKSELECT  0x00000008
#define LVS_EX_HEADERDRAGDROP  0x00000010
#define LVS_EX_FULLROWSELECT  0x00000020
#define LVS_EX_ONECLICKACTIVATE 0x00000040
#define LVS_EX_TWOCLICKACTIVATE 0x00000080
#define LVS_EX_FLATSB  0x00000100
#define LVS_EX_REGIONAL  0x00000200
#define LVS_EX_INFOTIP  0x00000400
#define LVS_EX_UNDERLINEHOT  0x00000800
#define LVS_EX_UNDERLINECOLD  0x00001000
#define LVS_EX_MULTIWORKAREAS  0x00002000
#define LVS_EX_LABELTIP  0x00004000
#define LVS_EX_BORDERSELECT  0x00008000
#define LVS_EX_DOUBLEBUFFER  0x00010000
#define LVS_EX_HIDELABELS  0x00020000
#define LVS_EX_SINGLEROW  0x00040000
#define LVS_EX_SNAPTOGRID  0x00080000
#define LVS_EX_SIMPLESELECT  0x00100000
#define LVS_EX_JUSTIFYCOLUMNS   0x00200000  // Icons are lined up in columns that use up the whole view area.
#define LVS_EX_TRANSPARENTBKGND 0x00400000  // Background is painted by the parent via WM_PRINTCLIENT
#define LVS_EX_TRANSPARENTSHADOWTEXT 0x00800000  // Enable shadow text on transparent backgrounds only (useful with bitmaps)
#define LVS_EX_AUTOAUTOARRANGE  0x01000000  // Icons automatically arrange if no icon positions have been set
#define LVS_EX_HEADERINALLVIEWS 0x02000000  // Display column header in all view modes
#define LVS_EX_AUTOCHECKSELECT  0x08000000
#define LVS_EX_AUTOSIZECOLUMNS  0x10000000
#define LVS_EX_COLUMNSNAPPOINTS 0x40000000
#define LVS_EX_COLUMNOVERFLOW   0x80000000

#define LVSIL_NORMAL  0
#define LVSIL_SMALL  1
#define LVSIL_STATE  2

#ifdef WINCE
	#define LVSIL_HEADER  3
	#define LVBD_DRAGSELECT  200
#endif /* WINCE */

#define LVIF_TEXT  0x0001
#define LVIF_IMAGE  0x0002
#define LVIF_PARAM  0x0004
#define LVIF_STATE  0x0008
#define LVIF_INDENT  0x0010
#define LVIF_NORECOMPUTE  0x0800
#define LVIF_GROUPID  0x0100
#define LVIF_COLUMNS  0x0200
#define LVIF_COLFMT 0x00010000

#define LVIS_FOCUSED  0x0001
#define LVIS_SELECTED  0x0002
#define LVIS_CUT  0x0004
#define LVIS_DROPHILITED  0x0008
#define LVIS_ACTIVATING  0x0020

#define LVIS_OVERLAYMASK  0x0F00
#define LVIS_STATEIMAGEMASK  0xF000

#define LPSTR_TEXTCALLBACKW  (-1)
#define LPSTR_TEXTCALLBACKA  (-1)

#define I_INDENTCALLBACK  (-1)
#define I_IMAGECALLBACK  (-1)
#define I_IMAGENONE  (-2)

#define I_GROUPIDCALLBACK  (-1)
#define I_GROUPIDNONE  (-2)

#define LVNI_ALL  0x0000
#define LVNI_FOCUSED  0x0001
#define LVNI_SELECTED  0x0002
#define LVNI_CUT  0x0004
#define LVNI_DROPHILITED  0x0008

#define LVNI_ABOVE  0x0100
#define LVNI_BELOW  0x0200
#define LVNI_TOLEFT  0x0400
#define LVNI_TORIGHT  0x0800

#define LVFI_PARAM  0x0001
#define LVFI_STRING  0x0002
#define LVFI_PARTIAL  0x0008
#define LVFI_WRAP  0x0020
#define LVFI_NEARESTXY  0x0040

#define LVIR_BOUNDS  0
#define LVIR_ICON  1
#define LVIR_LABEL  2
#define LVIR_SELECTBOUNDS  3

#define LVHT_NOWHERE  0x0001
#define LVHT_ONITEMICON  0x0002
#define LVHT_ONITEMLABEL  0x0004
#define LVHT_ONITEMSTATEICON  0x0008
#define LVHT_ONITEM  (LVHT_ONITEMICON|LVHT_ONITEMLABEL|LVHT_ONITEMSTATEICON)

#define LVHT_ABOVE  0x0008
#define LVHT_BELOW  0x0010
#define LVHT_TORIGHT  0x0020
#define LVHT_TOLEFT  0x0040

#define LVHT_EX_GROUP_HEADER       0x10000000
#define LVHT_EX_GROUP_FOOTER       0x20000000
#define LVHT_EX_GROUP_COLLAPSE     0x40000000
#define LVHT_EX_GROUP_BACKGROUND   0x80000000
#define LVHT_EX_GROUP_STATEICON    0x01000000
#define LVHT_EX_GROUP_SUBSETLINK   0x02000000
#define LVHT_EX_GROUP              (LVHT_EX_GROUP_BACKGROUND | LVHT_EX_GROUP_COLLAPSE | LVHT_EX_GROUP_FOOTER | LVHT_EX_GROUP_HEADER | LVHT_EX_GROUP_STATEICON | LVHT_EX_GROUP_SUBSETLINK)
#define LVHT_EX_ONCONTENTS         0x04000000 // On item AND not on the background
#define LVHT_EX_FOOTER             0x08000000

#define LVA_DEFAULT  0x0000
#define LVA_ALIGNLEFT  0x0001
#define LVA_ALIGNTOP  0x0002
#define LVA_SNAPTOGRID  0x0005

#define LVCF_FMT  0x0001
#define LVCF_WIDTH  0x0002
#define LVCF_TEXT  0x0004
#define LVCF_SUBITEM  0x0008
#define LVCF_IMAGE  0x0010
#define LVCF_ORDER  0x0020
#define LVCF_MINWIDTH           0x0040
#define LVCF_DEFAULTWIDTH       0x0080
#define LVCF_IDEALWIDTH         0x0100

#define LVCFMT_LEFT  0x0000
#define LVCFMT_RIGHT  0x0001
#define LVCFMT_CENTER  0x0002
#define LVCFMT_JUSTIFYMASK  0x0003

#define LVCFMT_IMAGE  0x0800
#define LVCFMT_BITMAP_ON_RIGHT  0x1000
#define LVCFMT_COL_HAS_IMAGES  0x8000

#define LVCFMT_FIXED_WIDTH          0x00100  // Can't resize the column; same as HDF_FIXEDWIDTH
#define LVCFMT_NO_DPI_SCALE         0x40000  // If not set, CCM_DPISCALE will govern scaling up fixed width
#define LVCFMT_FIXED_RATIO          0x80000  // Width will augment with the row height

// The following flags
#define LVCFMT_LINE_BREAK          0x100000 // Move to the top of the next list of columns
#define LVCFMT_FILL                0x200000 // Fill the remainder of the tile area. Might have a title.
#define LVCFMT_WRAP                0x400000 // This sub-item can be wrapped.
#define LVCFMT_NO_TITLE            0x800000  // This sub-item doesn't have an title.
#define LVCFMT_TILE_PLACEMENTMASK (LVCFMT_LINE_BREAK | LVCFMT_FILL)

#define LVCFMT_SPLITBUTTON        0x1000000 // Column is a split button; same as HDF_SPLITBUTTON

#define LVSCW_AUTOSIZE  -1
#define LVSCW_AUTOSIZE_USEHEADER  -2

#define LVSICF_NOINVALIDATEALL  0x00000001
#define LVSICF_NOSCROLL  0x00000002

#define LV_MAX_WORKAREAS  16

#define LVBKIF_SOURCE_NONE  0x00000000
#define LVBKIF_SOURCE_HBITMAP  0x00000001
#define LVBKIF_SOURCE_URL  0x00000002
#define LVBKIF_SOURCE_MASK  0x00000003
#define LVBKIF_STYLE_NORMAL  0x00000000
#define LVBKIF_STYLE_TILE  0x00000010
#define LVBKIF_STYLE_MASK  0x00000010
#define LVBKIF_FLAG_TILEOFFSET  0x00000100
#define LVBKIF_TYPE_WATERMARK  0x10000000
#define LVBKIF_FLAG_ALPHABLEND  0x20000000

#define LVKF_ALT  0x0001
#define LVKF_CONTROL  0x0002
#define LVKF_SHIFT  0x0004

#define LV_VIEW_ICON  0x0000
#define LV_VIEW_DETAILS  0x0001
#define LV_VIEW_SMALLICON  0x0002
#define LV_VIEW_LIST  0x0003
#define LV_VIEW_TILE  0x0004
#define LV_VIEW_MAX  0x0004

#define LVGF_NONE  0x00000000
#define LVGF_HEADER  0x00000001
#define LVGF_FOOTER  0x00000002
#define LVGF_STATE  0x00000004
#define LVGF_ALIGN  0x00000008
#define LVGF_GROUPID  0x00000010
#define LVGF_SUBTITLE           0x00000100  // pszSubtitle is valid
#define LVGF_TASK               0x00000200  // pszTask is valid
#define LVGF_DESCRIPTIONTOP     0x00000400  // pszDescriptionTop is valid
#define LVGF_DESCRIPTIONBOTTOM  0x00000800  // pszDescriptionBottom is valid
#define LVGF_TITLEIMAGE         0x00001000  // iTitleImage is valid
#define LVGF_EXTENDEDIMAGE      0x00002000  // iExtendedImage is valid
#define LVGF_ITEMS              0x00004000  // iFirstItem and cItems are valid
#define LVGF_SUBSET             0x00008000  // pszSubsetTitle is valid
#define LVGF_SUBSETITEMS        0x00010000  // readonly, cItems holds count of items in visible subset, iFirstItem is valid

#define LVGS_NORMAL  0x00000000
#define LVGS_COLLAPSED  0x00000001
#define LVGS_HIDDEN  0x00000002
#define LVGS_NOHEADER           0x00000004
#define LVGS_COLLAPSIBLE        0x00000008
#define LVGS_FOCUSED            0x00000010
#define LVGS_SELECTED           0x00000020
#define LVGS_SUBSETED           0x00000040
#define LVGS_SUBSETLINKFOCUSED  0x00000080

#define LVGA_HEADER_LEFT  0x00000001
#define LVGA_HEADER_CENTER  0x00000002
#define LVGA_HEADER_RIGHT  0x00000004
#define LVGA_FOOTER_LEFT  0x00000008
#define LVGA_FOOTER_CENTER  0x00000010
#define LVGA_FOOTER_RIGHT  0x00000020

#define LVGMF_NONE  0x00000000
#define LVGMF_BORDERSIZE  0x00000001
#define LVGMF_BORDERCOLOR  0x00000002
#define LVGMF_TEXTCOLOR  0x00000004

#define LVTVIF_AUTOSIZE  0x00000000
#define LVTVIF_FIXEDWIDTH  0x00000001
#define LVTVIF_FIXEDHEIGHT  0x00000002
#define LVTVIF_FIXEDSIZE  0x00000003
#define LVTVIF_EXTENDED       0x00000004

#define LVTVIM_TILESIZE  0x00000001
#define LVTVIM_COLUMNS  0x00000002
#define LVTVIM_LABELMARGIN  0x00000004

#define LVIM_AFTER  0x00000001

#define LVIF_DI_SETITEM  0x1000

#define LVGIT_UNFOLDED  0x0001

#define LVNSCH_DEFAULT  -1
#define LVNSCH_ERROR    -2
#define LVNSCH_IGNORE   -3

#define LVFIF_TEXT               0x00000001
#define LVFIF_STATE              0x00000002

#define LVFIS_FOCUSED            0x0001

#define LVFF_ITEMCOUNT          0x00000001

// dwItemType
#define LVCDI_ITEM 0x00000000
#define LVCDI_GROUP 0x00000001

// ListView custom draw return values
#define LVCDRF_NOSELECT 0x00010000
#define LVCDRF_NOGROUPFRAME 0x00020000

#define EMF_CENTERED            0x00000001

#define LV_FINDINFOA LVFINDINFOA
#define LV_FINDINFOW LVFINDINFOW
#define LV_FINDINFO LVFINDINFO

#define LV_HITTESTINFO LVHITTESTINFO

#define LV_COLUMNA LVCOLUMNA
#define LV_COLUMNW LVCOLUMNW
#define LV_COLUMN LVCOLUMN

#define LV_DISPINFOA NMLVDISPINFOA
#define LV_DISPINFOW NMLVDISPINFOW
#define LV_DISPINFO NMLVDISPINFO

#define LV_KEYDOWN NMLVKEYDOWN

#define NM_LISTVIEW NMLISTVIEW
#define NM_CACHEHINT NMLVCACHEHINT
#define NM_FINDITEMA NMLVFINDITEMA
#define NM_FINDITEMW NMLVFINDITEMW
#define NM_ODSTATECHANGE NMLVODSTATECHANGE

#define LVM_SETUNICODEFORMAT  CCM_SETUNICODEFORMAT
#define LVM_GETUNICODEFORMAT  CCM_GETUNICODEFORMAT
#define LVM_GETBKCOLOR  (LVM_FIRST+0)
#define LVM_SETBKCOLOR  (LVM_FIRST+1)
#define LVM_GETIMAGELIST  (LVM_FIRST+2)
#define LVM_SETIMAGELIST  (LVM_FIRST+3)
#define LVM_GETITEMCOUNT  (LVM_FIRST+4)
#define LVM_GETITEMA  (LVM_FIRST+5)
#define LVM_GETITEMW  (LVM_FIRST+75)
#define LVM_SETITEMA  (LVM_FIRST+6)
#define LVM_SETITEMW  (LVM_FIRST+76)
#define LVM_INSERTITEMA  (LVM_FIRST+7)
#define LVM_INSERTITEMW  (LVM_FIRST+77)
#define LVM_DELETEITEM  (LVM_FIRST+8)
#define LVM_DELETEALLITEMS  (LVM_FIRST+9)
#define LVM_GETCALLBACKMASK  (LVM_FIRST+10)
#define LVM_SETCALLBACKMASK  (LVM_FIRST+11)
#define LVM_GETNEXTITEM  (LVM_FIRST+12)
#define LVM_FINDITEMA  (LVM_FIRST+13)
#define LVM_FINDITEMW  (LVM_FIRST+83)
#define LVM_GETITEMRECT  (LVM_FIRST+14)
#define LVM_SETITEMPOSITION  (LVM_FIRST+15)
#define LVM_GETITEMPOSITION  (LVM_FIRST+16)
#define LVM_GETSTRINGWIDTHA  (LVM_FIRST+17)
#define LVM_GETSTRINGWIDTHW  (LVM_FIRST+87)
#define LVM_HITTEST  (LVM_FIRST+18)
#define LVM_ENSUREVISIBLE  (LVM_FIRST+19)
#define LVM_SCROLL  (LVM_FIRST+20)
#define LVM_REDRAWITEMS  (LVM_FIRST+21)
#define LVM_ARRANGE  (LVM_FIRST+22)
#define LVM_EDITLABELA  (LVM_FIRST+23)
#define LVM_EDITLABELW  (LVM_FIRST+118)
#define LVM_GETEDITCONTROL  (LVM_FIRST+24)
#define LVM_GETCOLUMNA  (LVM_FIRST+25)
#define LVM_GETCOLUMNW  (LVM_FIRST+95)
#define LVM_SETCOLUMNA  (LVM_FIRST+26)
#define LVM_SETCOLUMNW  (LVM_FIRST+96)
#define LVM_INSERTCOLUMNA  (LVM_FIRST+27)
#define LVM_INSERTCOLUMNW  (LVM_FIRST+97)
#define LVM_DELETECOLUMN  (LVM_FIRST+28)
#define LVM_GETCOLUMNWIDTH  (LVM_FIRST+29)
#define LVM_SETCOLUMNWIDTH  (LVM_FIRST+30)
#define LVM_GETHEADER  (LVM_FIRST+31)
#define LVM_CREATEDRAGIMAGE  (LVM_FIRST+33)
#define LVM_GETVIEWRECT  (LVM_FIRST+34)
#define LVM_GETTEXTCOLOR  (LVM_FIRST+35)
#define LVM_SETTEXTCOLOR  (LVM_FIRST+36)
#define LVM_GETTEXTBKCOLOR  (LVM_FIRST+37)
#define LVM_SETTEXTBKCOLOR  (LVM_FIRST+38)
#define LVM_GETTOPINDEX  (LVM_FIRST+39)
#define LVM_GETCOUNTPERPAGE  (LVM_FIRST+40)
#define LVM_GETORIGIN  (LVM_FIRST+41)
#define LVM_UPDATE  (LVM_FIRST+42)
#define LVM_SETITEMSTATE  (LVM_FIRST+43)
#define LVM_GETITEMSTATE  (LVM_FIRST+44)
#define LVM_GETITEMTEXTA  (LVM_FIRST+45)
#define LVM_GETITEMTEXTW  (LVM_FIRST+115)
#define LVM_SETITEMTEXTA  (LVM_FIRST+46)
#define LVM_SETITEMTEXTW  (LVM_FIRST+116)
#define LVM_SETITEMCOUNT  (LVM_FIRST+47)
#define LVM_SORTITEMS  (LVM_FIRST+48)
#define LVM_SETITEMPOSITION32  (LVM_FIRST+49)
#define LVM_GETSELECTEDCOUNT  (LVM_FIRST+50)
#define LVM_GETITEMSPACING  (LVM_FIRST+51)
#define LVM_GETISEARCHSTRINGA  (LVM_FIRST+52)
#define LVM_GETISEARCHSTRINGW  (LVM_FIRST+117)
#define LVM_SETICONSPACING  (LVM_FIRST+53)
#define LVM_SETEXTENDEDLISTVIEWSTYLE (LVM_FIRST+54)
#define LVM_GETEXTENDEDLISTVIEWSTYLE (LVM_FIRST+55)
#define LVM_GETSUBITEMRECT  (LVM_FIRST+56)
#define LVM_SUBITEMHITTEST  (LVM_FIRST+57)
#define LVM_SETCOLUMNORDERARRAY (LVM_FIRST+58)
#define LVM_GETCOLUMNORDERARRAY (LVM_FIRST+59)
#define LVM_SETHOTITEM  (LVM_FIRST+60)
#define LVM_GETHOTITEM  (LVM_FIRST+61)
#define LVM_SETHOTCURSOR  (LVM_FIRST+62)
#define LVM_GETHOTCURSOR  (LVM_FIRST+63)
#define LVM_APPROXIMATEVIEWRECT (LVM_FIRST+64)
#define LVM_SETWORKAREAS  (LVM_FIRST+65)
#define LVM_GETWORKAREAS  (LVM_FIRST+70)
#define LVM_GETNUMBEROFWORKAREAS (LVM_FIRST+73)
#define LVM_GETSELECTIONMARK  (LVM_FIRST+66)
#define LVM_SETSELECTIONMARK  (LVM_FIRST+67)
#define LVM_SETHOVERTIME  (LVM_FIRST+71)
#define LVM_GETHOVERTIME  (LVM_FIRST+72)
#define LVM_SETTOOLTIPS  (LVM_FIRST+74)
#define LVM_GETTOOLTIPS  (LVM_FIRST+78)
#define LVM_SORTITEMSEX  (LVM_FIRST+81)
#define LVM_SETBKIMAGEA  (LVM_FIRST+68)
#define LVM_SETBKIMAGEW  (LVM_FIRST+138)
#define LVM_GETBKIMAGEA  (LVM_FIRST+69)
#define LVM_GETBKIMAGEW  (LVM_FIRST+139)
#define LVM_SETSELECTEDCOLUMN  (LVM_FIRST+140)
#define LVM_SETTILEWIDTH  (LVM_FIRST+141)
#define LVM_SETVIEW  (LVM_FIRST+142)
#define LVM_GETVIEW  (LVM_FIRST+143)
#define LVM_INSERTGROUP  (LVM_FIRST+145)
#define LVM_SETGROUPINFO  (LVM_FIRST+147)
#define LVM_GETGROUPINFO  (LVM_FIRST+149)
#define LVM_REMOVEGROUP  (LVM_FIRST+150)
#define LVM_MOVEGROUP  (LVM_FIRST+151)
#define LVM_MOVEITEMTOGROUP  (LVM_FIRST+154)
#define LVM_SETGROUPMETRICS  (LVM_FIRST+155)
#define LVM_GETGROUPMETRICS  (LVM_FIRST+156)
#define LVM_ENABLEGROUPVIEW  (LVM_FIRST+157)
#define LVM_SORTGROUPS  (LVM_FIRST+158)
#define LVM_INSERTGROUPSORTED  (LVM_FIRST+159)
#define LVM_REMOVEALLGROUPS  (LVM_FIRST+160)
#define LVM_HASGROUP  (LVM_FIRST+161)
#define LVM_SETTILEVIEWINFO  (LVM_FIRST+162)
#define LVM_GETTILEVIEWINFO  (LVM_FIRST+163)
#define LVM_SETTILEINFO  (LVM_FIRST+164)
#define LVM_GETTILEINFO  (LVM_FIRST+165)
#define LVM_SETINSERTMARK  (LVM_FIRST+166)
#define LVM_GETINSERTMARK  (LVM_FIRST+167)
#define LVM_INSERTMARKHITTEST  (LVM_FIRST+168)
#define LVM_GETINSERTMARKRECT  (LVM_FIRST+169)
#define LVM_SETINSERTMARKCOLOR (LVM_FIRST+170)
#define LVM_GETINSERTMARKCOLOR  (LVM_FIRST+171)
#define LVM_SETINFOTIP  (LVM_FIRST+173)
#define LVM_GETSELECTEDCOLUMN  (LVM_FIRST+174)
#define LVM_ISGROUPVIEWENABLED  (LVM_FIRST+175)
#define LVM_GETOUTLINECOLOR  (LVM_FIRST+176)
#define LVM_SETOUTLINECOLOR  (LVM_FIRST+177)
#define LVM_CANCELEDITLABEL  (LVM_FIRST+179)
#define LVM_MAPINDEXTOID  (LVM_FIRST+180)
#define LVM_MAPIDTOINDEX  (LVM_FIRST+181)
#define LVM_ISITEMVISIBLE    (LVM_FIRST + 182)
#define LVM_GETEMPTYTEXT (LVM_FIRST + 204)
#define LVM_GETFOOTERRECT (LVM_FIRST + 205)
#define LVM_GETFOOTERINFO (LVM_FIRST + 206)
#define LVM_GETFOOTERITEMRECT (LVM_FIRST + 207)
#define LVM_GETFOOTERITEM (LVM_FIRST + 208)
#define LVM_GETITEMINDEXRECT    (LVM_FIRST + 209)
#define LVM_SETITEMINDEXSTATE   (LVM_FIRST + 210)
#define LVM_GETNEXTITEMINDEX    (LVM_FIRST + 211)

#define LVN_ITEMCHANGING  (LVN_FIRST-0)
#define LVN_ITEMCHANGED  (LVN_FIRST-1)
#define LVN_INSERTITEM  (LVN_FIRST-2)
#define LVN_DELETEITEM  (LVN_FIRST-3)
#define LVN_DELETEALLITEMS  (LVN_FIRST-4)
#define LVN_BEGINLABELEDITA  (LVN_FIRST-5)
#define LVN_BEGINLABELEDITW  (LVN_FIRST-75)
#define LVN_ENDLABELEDITA  (LVN_FIRST-6)
#define LVN_ENDLABELEDITW  (LVN_FIRST-76)
#define LVN_COLUMNCLICK  (LVN_FIRST-8)
#define LVN_BEGINDRAG  (LVN_FIRST-9)
#define LVN_BEGINRDRAG  (LVN_FIRST-11)
#define LVN_ODCACHEHINT  (LVN_FIRST-13)
#define LVN_ODFINDITEMA  (LVN_FIRST-52)
#define LVN_ODFINDITEMW  (LVN_FIRST-79)
#define LVN_ITEMACTIVATE  (LVN_FIRST-14)
#define LVN_ODSTATECHANGED  (LVN_FIRST-15)
#define LVN_HOTTRACK  (LVN_FIRST-21)
#define LVN_GETDISPINFOA  (LVN_FIRST-50)
#define LVN_SETDISPINFOA  (LVN_FIRST-51)
#define LVN_KEYDOWN  (LVN_FIRST-55)
#define LVN_MARQUEEBEGIN  (LVN_FIRST-56)
#define LVN_GETINFOTIPA  (LVN_FIRST-57)
#define LVN_INCREMENTALSEARCHA   (LVN_FIRST-62)
#define LVN_INCREMENTALSEARCHW   (LVN_FIRST-63)
#define LVN_COLUMNDROPDOWN       (LVN_FIRST-64)
#define LVN_COLUMNOVERFLOWCLICK  (LVN_FIRST-66)
#define LVN_GETDISPINFOW  (LVN_FIRST-77)
#define LVN_SETDISPINFOW  (LVN_FIRST-78)
#define LVN_GETINFOTIPW  (LVN_FIRST-58)
#define LVN_BEGINSCROLL  (LVN_FIRST-80)
#define LVN_ENDSCROLL  (LVN_FIRST-81)
#define LVN_LINKCLICK (LVN_FIRST-84)
#define LVN_GETEMPTYMARKUP (LVN_FIRST-87)

NMLVEMPTYMARKUP STRUCT
	hdr NMHDR
	dwFlags DD
	szMarkup DW L_MAX_URL_LENGTH DUP
ENDS

LVFOOTERITEM STRUCT
	mask DD
	iItem DD
	pszText PTR
	cchTextMax DD
	state DD
	stateMask DD
ENDS

LVFOOTERINFO STRUCT
	mask DD
	pszText PTR
	cchTextMax DD
	cItems DD
ENDS

LVITEMA STRUCT
	mask DD
	iItem DD
	iSubItem DD
	state DD
	stateMask DD
	pszText PTR
	cchTextMax DD
	iImage DD
	lParam DD
	iIndent DD
	iGroupId DD
	cColumns DD
	puColumns PTR
#IFDEF VISTA
	piColFmt PTR
	iGroup DD
#ENDIF
ENDS

#define LVITEMW LVITEMA
#define LV_ITEMA LVITEMA
#define LV_ITEMW LVITEMW
#define LV_ITEM LVITEM

LVFINDINFOA STRUCT
	flags DD
	psz PTR
	lParam LPARAM
	pt POINT
	vkDirection DD
ENDS

#define LVFINDINFOW LVFINDINFOA

LVHITTESTINFO STRUCT
	pt POINT
	flags DD
	iItem DD
	iSubItem DD
	iGroup DD
ENDS

LVCOLUMNA STRUCT
	mask DD
	fmt DD
	cx DD
	pszText PTR
	cchTextMax DD
	iSubItem DD
	iImage DD
	iOrder DD
#IFDEF VISTA
	cxMin DD
	cxDefault DD
	cxIdeal DD
#ENDIF
ENDS

#define LVCOLUMNW LVCOLUMNA

LVBKIMAGEA STRUCT
	ulFlags DD
	hbm HANDLE
	pszImage PTR
	cchImageMax DD
	xOffsetPercent DD
	yOffsetPercent DD
ENDS

#define LVBKIMAGEW LVBKIMAGEA

NMLISTVIEW STRUCT
	hdr NMHDR
	iItem DD
	iSubItem DD
	uNewState DD
	uOldState DD
	uChanged DD
	ptAction POINT
	lParam LPARAM
ENDS

NMITEMACTIVATE STRUCT
	hdr NMHDR
	iItem DD
	iSubItem DD
	uNewState DD
	uOldState DD
	uChanged DD
	ptAction POINT
	lParam LPARAM
	uKeyFlags DD
ENDS

NMLVCUSTOMDRAW STRUCT
	nmcd NMCUSTOMDRAW
	clrText DD
	clrTextBk DD
	iSubItem DD
	dwItemType DD
	clrFace DD
	iIconEffect DD
	iIconPhase DD
	iPartId DD
	iStateId DD
	rcText RECT
	uAlign DD
ENDS

NMLVCACHEHINT STRUCT
	hdr NMHDR
	iFrom DD
	iTo DD
ENDS

NMLVFINDITEMA STRUCT
	hdr NMHDR
	iStart DD
	lvfi LVFINDINFOA
ENDS

NMLVFINDITEMW STRUCT
	hdr NMHDR
	iStart DD
	lvfi LVFINDINFOW
ENDS

NMLVODSTATECHANGE STRUCT
	hdr NMHDR
	iFrom DD
	iTo DD
	uNewState DD
	uOldState DD
ENDS

NMLVDISPINFOA STRUCT
	hdr NMHDR
	item LVITEMA
ENDS

NMLVDISPINFOW STRUCT
	hdr NMHDR
	item LVITEMW
ENDS

NMLVKEYDOWN STRUCT
	hdr NMHDR
	wVKey DW
	flags DD
ENDS

NMLVGETINFOTIPA STRUCT
	hdr NMHDR
	dwFlags DD
	pszText PTR
	cchTextMax DD
	iItem DD
	iSubItem DD
	lParam LPARAM
ENDS

#define NMLVGETINFOTIPW NMLVGETINFOTIPA

LVGROUP STRUCT
	cbSize DD
	mask DD
	pszHeader PTR
	cchHeader DD
	pszFooter PTR
	cchFooter DD
	iGroupId DD
	stateMask DD
	state DD
	uAlign DD
#IFDEF VISTA
	pszSubtitle PTR
	cchSubtitle DD
	pszTask PTR
	cchTask DD
	pszDescriptionTop PTR
	cchDescriptionTop DD
	pszDescriptionBottom PTR
	cchDescriptionBottom DD
	iTitleImage DD
	iExtendedImage DD
	iFirstItem DD
	cItems DD
	pszSubsetTitle PTR
	cchSubsetTitle DD
#ENDIF
ENDS

LVGROUPMETRICS STRUCT
	cbSize DD
	mask DD
	Left DD
	Top DD
	Right DD
	Bottom DD
	crLeft DD
	crTop DD
	crRight DD
	crBottom DD
	crHeader DD
	crFooter DD
ENDS

LVINSERTGROUPSORTED STRUCT
	pfnGroupCompare PTR
	pvData PTR
	lvGroup LVGROUP
ENDS

LVTILEVIEWINFO STRUCT
	cbSize DD
	dwMask DD
	dwFlags DD
	sizeTile SIZE
	cLines DD
	rcLabelMargin RECT
ENDS

LVTILEINFO STRUCT
	cbSize DD
	iItem DD
	cColumns DD
	puColumns PTR
#IFDEF VISTA
	piColFmt PTR
#ENDIF
ENDS

LVINSERTMARK STRUCT
	cbSize DD
	dwFlags DD
	iItem DD
	dwReserved DD
ENDS

LVSETINFOTIP STRUCT
	cbSize DD
	dwFlags DD
	pszText PTR
	iItem DD
	iSubItem DD
#IFDEF VISTA
	hbmp HANDLE
#ENDIF
ENDS

NMLVSCROLL STRUCT
	hdr NMHDR
	dx DD
	dy DD
ENDS

#IFDEF UNICODE
	#define WC_LISTVIEW  WC_LISTVIEWW
	#define LVITEM LVITEMW
	#define LVITEM_V1_SIZE LVITEMW_V1_SIZE
	#define LVFINDINFO LVFINDINFOW
	#define LVCOLUMN LVCOLUMNW
	#define LVCOLUMN_V1_SIZE LVCOLUMNW_V1_SIZE
	#define LVBKIMAGE LVBKIMAGEW
	#define NM_FINDITEM NM_FINDITEMW
	#define NMLVFINDITEM NMLVFINDITEMW
	#define NMLVDISPINFO NMLVDISPINFOW
	#define NMLVGETINFOTIP NMLVGETINFOTIPW
	#define LVM_GETITEM LVM_GETITEMW
	#define LVM_SETITEM LVM_SETITEMW
	#define LVM_INSERTITEM LVM_INSERTITEMW
	#define LVM_FINDITEM LVM_FINDITEMW
	#define LVM_GETSTRINGWIDTH LVM_GETSTRINGWIDTHW
	#define LVM_EDITLABEL LVM_EDITLABELW
	#define LVM_GETCOLUMN LVM_GETCOLUMNW
	#define LVM_SETCOLUMN LVM_SETCOLUMNW
	#define LVM_INSERTCOLUMN LVM_INSERTCOLUMNW
	#define LVM_GETITEMTEXT LVM_GETITEMTEXTW
	#define LVM_SETITEMTEXT LVM_SETITEMTEXTW
	#define LVM_GETISEARCHSTRING LVM_GETISEARCHSTRINGW
	#define LVM_SETBKIMAGE LVM_SETBKIMAGEW
	#define LVM_GETBKIMAGE LVM_GETBKIMAGEW
	#define LVN_ODFINDITEM LVN_ODFINDITEMW
	#define LVN_BEGINLABELEDIT LVN_BEGINLABELEDITW
	#define LVN_ENDLABELEDIT LVN_ENDLABELEDITW
	#define LVN_GETDISPINFO LVN_GETDISPINFOW
	#define LVN_SETDISPINFO LVN_SETDISPINFOW
	#define LVN_GETINFOTIP LVN_GETINFOTIPW
	#define LPSTR_TEXTCALLBACK LPSTR_TEXTCALLBACKW
#else
	#define WC_LISTVIEW  WC_LISTVIEWA
	#define LVITEM LVITEMA
	#define LVITEM_V1_SIZE LVITEMA_V1_SIZE
	#define LVFINDINFO LVFINDINFOA
	#define LVCOLUMN LVCOLUMNA
	#define LVCOLUMN_V1_SIZE LVCOLUMNA_V1_SIZE
	#define LVBKIMAGE LVBKIMAGEA
	#define NM_FINDITEM NM_FINDITEMA
	#define NMLVFINDITEM NMLVFINDITEMA
	#define NMLVDISPINFO NMLVDISPINFOA
	#define NMLVGETINFOTIP NMLVGETINFOTIPA
	#define LVM_GETITEM LVM_GETITEMA
	#define LVM_SETITEM LVM_SETITEMA
	#define LVM_INSERTITEM LVM_INSERTITEMA
	#define LVM_FINDITEM LVM_FINDITEMA
	#define LVM_GETSTRINGWIDTH LVM_GETSTRINGWIDTHA
	#define LVM_EDITLABEL LVM_EDITLABELA
	#define LVM_GETCOLUMN LVM_GETCOLUMNA
	#define LVM_SETCOLUMN LVM_SETCOLUMNA
	#define LVM_INSERTCOLUMN LVM_INSERTCOLUMNA
	#define LVM_GETITEMTEXT LVM_GETITEMTEXTA
	#define LVM_SETITEMTEXT LVM_SETITEMTEXTA
	#define LVM_GETISEARCHSTRING LVM_GETISEARCHSTRINGA
	#define LVM_SETBKIMAGE LVM_SETBKIMAGEA
	#define LVM_GETBKIMAGE LVM_GETBKIMAGEA
	#define LVN_ODFINDITEM LVN_ODFINDITEMA
	#define LVN_BEGINLABELEDIT LVN_BEGINLABELEDITA
	#define LVN_ENDLABELEDIT LVN_ENDLABELEDITA
	#define LVN_GETDISPINFO LVN_GETDISPINFOA
	#define LVN_SETDISPINFO LVN_SETDISPINFOA
	#define LVN_GETINFOTIP LVN_GETINFOTIPA
	#define LPSTR_TEXTCALLBACK LPSTR_TEXTCALLBACKA
#endif

/* TreeView Control *********************************************************/

#define WC_TREEVIEWA  A"SysTreeView32"
#define WC_TREEVIEWW  L"SysTreeView32"

#define TVS_HASBUTTONS  0x0001
#define TVS_HASLINES  0x0002
#define TVS_LINESATROOT  0x0004
#define TVS_EDITLABELS  0x0008
#define TVS_DISABLEDRAGDROP  0x0010
#define TVS_SHOWSELALWAYS  0x0020
#define TVS_RTLREADING  0x0040

#define TVS_NOTOOLTIPS  0x0080
#define TVS_CHECKBOXES  0x0100
#define TVS_TRACKSELECT  0x0200
#define TVS_SINGLEEXPAND  0x0400
#define TVS_INFOTIP  0x0800
#define TVS_FULLROWSELECT  0x1000
#define TVS_NOSCROLL  0x2000
#define TVS_NONEVENHEIGHT  0x4000
#define TVS_NOHSCROLL  0x8000

#define TVS_EX_MULTISELECT          0x0002
#define TVS_EX_DOUBLEBUFFER         0x0004
#define TVS_EX_NOINDENTSTATE        0x0008
#define TVS_EX_RICHTOOLTIP          0x0010
#define TVS_EX_AUTOHSCROLL          0x0020
#define TVS_EX_FADEINOUTEXPANDOS    0x0040
#define TVS_EX_PARTIALCHECKBOXES    0x0080
#define TVS_EX_EXCLUSIONCHECKBOXES  0x0100
#define TVS_EX_DIMMEDCHECKBOXES     0x0200
#define TVS_EX_DRAWIMAGEASYNC       0x0400

#define TVIF_TEXT  0x0001
#define TVIF_IMAGE  0x0002
#define TVIF_PARAM  0x0004
#define TVIF_STATE  0x0008
#define TVIF_HANDLE  0x0010
#define TVIF_SELECTEDIMAGE  0x0020
#define TVIF_CHILDREN  0x0040
#define TVIF_INTEGRAL  0x0080

#define TVIS_SELECTED  0x0002
#define TVIS_CUT  0x0004
#define TVIS_DROPHILITED  0x0008
#define TVIS_BOLD  0x0010
#define TVIS_EXPANDED  0x0020
#define TVIS_EXPANDEDONCE  0x0040
#define TVIS_EXPANDPARTIAL  0x0080
#define TVIS_OVERLAYMASK  0x0F00
#define TVIS_STATEIMAGEMASK  0xF000
#define TVIS_USERMASK  0xF000

#define TVIS_EX_FLAT            0x0001
#define TVIS_EX_DISABLED        0x0002
#define TVIS_EX_ALL             0x0002

#define TVE_COLLAPSE  0x0001
#define TVE_EXPAND  0x0002
#define TVE_TOGGLE  0x0003
#define TVE_EXPANDPARTIAL  0x4000
#define TVE_COLLAPSERESET  0x8000

#define TVSIL_NORMAL  0
#define TVSIL_STATE  2

#define TVGN_ROOT  0x0000
#define TVGN_NEXT  0x0001
#define TVGN_PREVIOUS  0x0002
#define TVGN_PARENT  0x0003
#define TVGN_CHILD  0x0004
#define TVGN_FIRSTVISIBLE  0x0005
#define TVGN_NEXTVISIBLE  0x0006
#define TVGN_PREVIOUSVISIBLE  0x0007
#define TVGN_DROPHILITE  0x0008
#define TVGN_CARET  0x0009
#define TVGN_LASTVISIBLE  0x000A
#define TVGN_NEXTSELECTED 0x000B

#define TVSI_NOSINGLEEXPAND  0x8000
#define TVHT_NOWHERE  0x0001
#define TVHT_ONITEMICON  0x0002
#define TVHT_ONITEMLABEL  0x0004
#define TVHT_ONITEM  (TVHT_ONITEMICON|TVHT_ONITEMLABEL|TVHT_ONITEMSTATEICON)
#define TVHT_ONITEMINDENT  0x0008
#define TVHT_ONITEMBUTTON  0x0010
#define TVHT_ONITEMRIGHT  0x0020
#define TVHT_ONITEMSTATEICON  0x0040
#define TVHT_ABOVE  0x0100
#define TVHT_BELOW  0x0200
#define TVHT_TORIGHT  0x0400
#define TVHT_TOLEFT  0x0800

#define TVGIPR_BUTTON 0x0001

#define TVM_INSERTITEMA  (TV_FIRST+0)
#define TVM_INSERTITEMW  (TV_FIRST+50)
#define TVM_DELETEITEM  (TV_FIRST+1)
#define TVM_EXPAND  (TV_FIRST+2)
#define TVM_GETITEMRECT  (TV_FIRST+4)
#define TVM_GETCOUNT  (TV_FIRST+5)
#define TVM_GETINDENT  (TV_FIRST+6)
#define TVM_SETINDENT  (TV_FIRST+7)
#define TVM_GETIMAGELIST  (TV_FIRST+8)
#define TVM_SETIMAGELIST  (TV_FIRST+9)
#define TVM_GETNEXTITEM  (TV_FIRST+10)
#define TVM_SELECTITEM  (TV_FIRST+11)
#define TVM_GETITEMA  (TV_FIRST+12)
#define TVM_EDITLABELA  (TV_FIRST+14)
#define TVM_SETITEMA  (TV_FIRST+13)
#define TVM_GETEDITCONTROL  (TV_FIRST+15)
#define TVM_GETVISIBLECOUNT  (TV_FIRST+16)
#define TVM_HITTEST  (TV_FIRST+17)
#define TVM_CREATEDRAGIMAGE  (TV_FIRST+18)
#define TVM_SORTCHILDREN  (TV_FIRST+19)
#define TVM_ENSUREVISIBLE  (TV_FIRST+20)
#define TVM_SORTCHILDRENCB  (TV_FIRST+21)
#define TVM_ENDEDITLABELNOW  (TV_FIRST+22)
#define TVM_GETISEARCHSTRINGA  (TV_FIRST+23)
#define TVM_SETTOOLTIPS  (TV_FIRST+24)
#define TVM_GETTOOLTIPS  (TV_FIRST+25)
#define TVM_SETINSERTMARK  (TV_FIRST+26)
#define TVM_SETUNICODEFORMAT  CCM_SETUNICODEFORMAT
#define TVM_GETUNICODEFORMAT  CCM_GETUNICODEFORMAT
#define TVM_SETITEMHEIGHT  (TV_FIRST+27)
#define TVM_GETITEMHEIGHT  (TV_FIRST+28)
#define TVM_SETBKCOLOR  (TV_FIRST+29)
#define TVM_SETTEXTCOLOR  (TV_FIRST+30)
#define TVM_GETBKCOLOR  (TV_FIRST+31)
#define TVM_GETTEXTCOLOR  (TV_FIRST+32)
#define TVM_SETSCROLLTIME  (TV_FIRST+33)
#define TVM_GETSCROLLTIME  (TV_FIRST+34)
#define TVM_SETINSERTMARKCOLOR  (TV_FIRST+37)
#define TVM_GETINSERTMARKCOLOR  (TV_FIRST+38)
#define TVM_GETITEMSTATE  (TV_FIRST+39)
#define TVM_SETLINECOLOR  (TV_FIRST+40)
#define TVM_GETLINECOLOR  (TV_FIRST+41)
#define TVM_MAPACCIDTOHTREEITEM  (TV_FIRST+42)
#define TVM_MAPHTREEITEMTOACCID  (TV_FIRST+43)
#define TVM_SETEXTENDEDSTYLE      (TV_FIRST + 44)
#define TVM_GETEXTENDEDSTYLE      (TV_FIRST + 45)
#define TVM_SETAUTOSCROLLINFO   (TV_FIRST + 59)

#define TVM_GETITEMW  (TV_FIRST+62)
#define TVM_SETITEMW  (TV_FIRST+63)
#define TVM_GETISEARCHSTRINGW  (TV_FIRST+64)
#define TVM_EDITLABELW  (TV_FIRST+65)

#define TVM_GETSELECTEDCOUNT       (TV_FIRST + 70)
#define TVM_SHOWINFOTIP            (TV_FIRST + 71)
#define TVM_GETITEMPARTRECT         (TV_FIRST + 72)

#define TVN_SELCHANGINGA  (TVN_FIRST-1)
#define TVN_SELCHANGINGW  (TVN_FIRST-50)
#define TVN_SELCHANGEDA  (TVN_FIRST-2)
#define TVN_SELCHANGEDW  (TVN_FIRST-51)
#define TVN_GETDISPINFOA  (TVN_FIRST-3)
#define TVN_GETDISPINFOW  (TVN_FIRST-52)
#define TVN_SETDISPINFOA  (TVN_FIRST-4)
#define TVN_SETDISPINFOW  (TVN_FIRST-53)
#define TVN_ITEMEXPANDINGA  (TVN_FIRST-5)
#define TVN_ITEMEXPANDINGW  (TVN_FIRST-54)
#define TVN_ITEMEXPANDEDA  (TVN_FIRST-6)
#define TVN_ITEMEXPANDEDW  (TVN_FIRST-55)
#define TVN_BEGINDRAGA  (TVN_FIRST-7)
#define TVN_BEGINDRAGW  (TVN_FIRST-56)
#define TVN_BEGINRDRAGA  (TVN_FIRST-8)
#define TVN_BEGINRDRAGW  (TVN_FIRST-57)
#define TVN_DELETEITEMA  (TVN_FIRST-9)
#define TVN_DELETEITEMW  (TVN_FIRST-58)
#define TVN_BEGINLABELEDITA  (TVN_FIRST-10)
#define TVN_BEGINLABELEDITW  (TVN_FIRST-59)
#define TVN_ENDLABELEDITA  (TVN_FIRST-11)
#define TVN_ENDLABELEDITW  (TVN_FIRST-60)
#define TVN_KEYDOWN  (TVN_FIRST-12)
#define TVN_GETINFOTIPA  (TVN_FIRST-13)
#define TVN_GETINFOTIPW  (TVN_FIRST-14)
#define TVN_SINGLEEXPAND  (TVN_FIRST-15)
#define TVN_ITEMCHANGINGA       (TVN_FIRST-16)
#define TVN_ITEMCHANGINGW       (TVN_FIRST-17)
#define TVN_ITEMCHANGEDA        (TVN_FIRST-18)
#define TVN_ITEMCHANGEDW        (TVN_FIRST-19)
#define TVN_ASYNCDRAW           (TVN_FIRST-20)

#define TVC_UNKNOWN  0x0000
#define TVC_BYMOUSE  0x0001
#define TVC_BYKEYBOARD  0x0002

#define TVIF_DI_SETITEM  0x1000

#define TVNRET_DEFAULT  0
#define TVNRET_SKIPOLD  1
#define TVNRET_SKIPNEW  2

#define I_CHILDRENCALLBACK  (-1)

#define TVI_ROOT -0x10000
#define TVI_FIRST -0x0FFFF
#define TVI_LAST -0x0FFFE
#define TVI_SORT -0x0FFFD

#define TV_INSERTSTRUCTA TVINSERTSTRUCTA
#define TV_INSERTSTRUCTW TVINSERTSTRUCTW
#define TV_INSERTSTRUCT TVINSERTSTRUCT
#define TV_HITTESTINFO TVHITTESTINFO

#define TV_SORTCB TVSORTCB
#define NM_TREEVIEWW NMTREEVIEWW
#define NM_TREEVIEWA NMTREEVIEWA
#define NM_TREEVIEW NMTREEVIEW

TVITEMA STRUCT
	mask DD
	hItem HANDLE
	state DD
	stateMask DD
	pszText PTR
	cchTextMax DD
	iImage DD
	iSelectedImage DD
	cChildren DD
	lParam LPARAM
ENDS

#define TVITEMW TVITEMA
#define TV_ITEMA TVITEMA
#define TV_ITEMW TVITEMW
#define TV_ITEM TVITEM

TVITEMEXA STRUCT
	mask DD
	hItem HANDLE
	state DD
	stateMask DD
	pszText PTR
	cchTextMax DD
	iImage DD
	iSelectedImage DD
	cChildren DD
	lParam LPARAM
	iIntegral DD
#IFDEF VISTA
	uStateEx DD
	hwnd HANDLE
	iExpandedImage DD
#ENDIF
ENDS

#define TVITEMEXW TVITEMEXA
#define TV_ITEMEXA TVITEMEXA
#define TV_ITEMEXW TVITEMEXW

TVDISPINFOEXA STRUCT
	hdr NMHDR
	item TVITEMEXA
ENDS

#define TVDISPINFOEXW TVDISPINFOEXA
#define TVDISPINFOEX TVDISPINFOEXA

NMTVITEMCHANGE STRUCT
	hdr NMHDR
	uChanged DD
	hItem HANDLE
	uStateNew DD
	uStateOld DD
	lParam LPARAM
ENDS

NMTVASYNCDRAW STRUCT
	hdr NMHDR
	pimldp PTR
	hr HANDLE
	hItem HANDLE
	lParam LPARAM
	dwRetFlags DD
	iRetImageIndex DD
ENDS

TVGETITEMPARTRECTINFO STRUCT
	hti HANDLE
	prc PTR
	partID DD
ENDS

TVINSERTSTRUCTA STRUCT
	hParent HANDLE
	hInsertAfter HANDLE
	UNION
		itemex TVITEMEXA
		item TVITEMA
	ENDUNION
ENDS

TVINSERTSTRUCTW STRUCT
	hParent HANDLE
	hInsertAfter HANDLE
	UNION
		itemex TVITEMEXW
		item TVITEMW
	ENDUNION
ENDS

TVHITTESTINFO STRUCT
	pt POINT
	flags DD
	hItem HANDLE
ENDS

TVSORTCB STRUCT
	hParent HANDLE
	lpfnCompare PTR
	lParam LPARAM
ENDS

NMTREEVIEWA STRUCT
	hdr NMHDR
	action DD
	itemOld TVITEMA
	itemNew TVITEMA
	ptDrag POINT
ENDS

NMTREEVIEWW STRUCT
	hdr NMHDR
	action DD
	itemOld TVITEMW
	itemNew TVITEMW
	ptDrag POINT
ENDS

NMTVDISPINFOA STRUCT
	hdr NMHDR
	item TVITEMA
ENDS

NMTVDISPINFOW STRUCT
	hdr NMHDR
	item TVITEMW
ENDS

NMTVKEYDOWN STRUCT
	hdr NMHDR
	wVKey DW
	flags DD
ENDS

NMTVCUSTOMDRAW STRUCT
	nmcd NMCUSTOMDRAW
	clrText DD
	clrTextBk DD
	iLevel DD
ENDS

NMTVGETINFOTIPA STRUCT
	hdr NMHDR
	pszText PTR
	cchTextMax DD
	hItem HANDLE
	lParam LPARAM
ENDS

NMTVSTATEIMAGECHANGING STRUCT
	hdr NMHDR
	hti HANDLE
	iOldStateImageIndex DD
	iNewStateImageIndex DD
ENDS

#define NMTVGETINFOTIPW NMTVGETINFOTIPA

#define TVCDRF_NOIMAGES  0x00010000

#IFDEF UNICODE
	#define  WC_TREEVIEW  WC_TREEVIEWW  
	#define TVITEMEX TVITEMEXW
	#define TVITEM TVITEMW
	#define TVINSERTSTRUCT TVINSERTSTRUCTW
	#define TVINSERTSTRUCT_V1_SIZE TVINSERTSTRUCTW_V1_SIZE
	#define TVM_INSERTITEM TVM_INSERTITEMW
	#define TVM_GETITEM TVM_GETITEMW
	#define TVM_SETITEM TVM_SETITEMW
	#define TVM_EDITLABEL TVM_EDITLABELW
	#define TVM_GETISEARCHSTRING TVM_GETISEARCHSTRINGW
	#define NMTREEVIEW NMTREEVIEWW
	#define NMTVDISPINFO NMTVDISPINFOW
	#define TVN_SELCHANGING TVN_SELCHANGINGW
	#define TVN_SELCHANGED TVN_SELCHANGEDW
	#define TVN_GETDISPINFO TVN_GETDISPINFOW
	#define TVN_SETDISPINFO TVN_SETDISPINFOW
	#define TVN_ITEMEXPANDING TVN_ITEMEXPANDINGW
	#define TVN_ITEMEXPANDED TVN_ITEMEXPANDEDW
	#define TVN_BEGINDRAG TVN_BEGINDRAGW
	#define TVN_BEGINRDRAG TVN_BEGINRDRAGW
	#define TVN_DELETEITEM TVN_DELETEITEMW
	#define TVN_BEGINLABELEDIT TVN_BEGINLABELEDITW
	#define TVN_ENDLABELEDIT TVN_ENDLABELEDITW
	#define TVN_GETINFOTIP TVN_GETINFOTIPW
	#define TVN_ITEMCHANGING TVN_ITEMCHANGINGW
	#define TVN_ITEMCHANGED TVN_ITEMCHANGEDW
	#define NMTVGETINFOTIP NMTVGETINFOTIPW
#else
	#define  WC_TREEVIEW  WC_TREEVIEWA
	#define TVITEMEX TVITEMEXA
	#define TVITEM TVITEMA
	#define TVINSERTSTRUCT TVINSERTSTRUCTA
	#define TVINSERTSTRUCT_V1_SIZE TVINSERTSTRUCTA_V1_SIZE
	#define TVM_INSERTITEM TVM_INSERTITEMA
	#define TVM_GETITEM TVM_GETITEMA
	#define TVM_SETITEM TVM_SETITEMA
	#define TVM_EDITLABEL TVM_EDITLABELA
	#define TVM_GETISEARCHSTRING TVM_GETISEARCHSTRINGA
	#define NMTREEVIEW NMTREEVIEWA
	#define NMTVDISPINFO NMTVDISPINFOA
	#define TVN_SELCHANGING TVN_SELCHANGINGA
	#define TVN_SELCHANGED TVN_SELCHANGEDA
	#define TVN_GETDISPINFO TVN_GETDISPINFOA
	#define TVN_SETDISPINFO TVN_SETDISPINFOA
	#define TVN_ITEMEXPANDING TVN_ITEMEXPANDINGA
	#define TVN_ITEMEXPANDED TVN_ITEMEXPANDEDA
	#define TVN_BEGINDRAG TVN_BEGINDRAGA
	#define TVN_BEGINRDRAG TVN_BEGINRDRAGA
	#define TVN_DELETEITEM TVN_DELETEITEMA
	#define TVN_BEGINLABELEDIT TVN_BEGINLABELEDITA
	#define TVN_ENDLABELEDIT TVN_ENDLABELEDITA
	#define TVN_GETINFOTIP TVN_GETINFOTIPA
	#define TVN_ITEMCHANGING TVN_ITEMCHANGINGA
	#define TVN_ITEMCHANGED TVN_ITEMCHANGEDA
	#define NMTVGETINFOTIP NMTVGETINFOTIPA
#endif

/* ComboboxEx Control *******************************************************/

#define WC_COMBOBOXEXW  L"ComboBoxEx32"
#define WC_COMBOBOXEXA  A"ComboBoxEx32"

#define CBEIF_TEXT  0x00000001
#define CBEIF_IMAGE  0x00000002
#define CBEIF_SELECTEDIMAGE  0x00000004
#define CBEIF_OVERLAY  0x00000008
#define CBEIF_INDENT  0x00000010
#define CBEIF_LPARAM  0x00000020
#define CBEIF_DI_SETITEM  0x10000000

#define CBEM_INSERTITEMA  (WM_USER+1)
#define CBEM_SETIMAGELIST  (WM_USER+2)
#define CBEM_GETIMAGELIST  (WM_USER+3)
#define CBEM_GETITEMA  (WM_USER+4)
#define CBEM_SETITEMA  (WM_USER+5)
#define CBEM_DELETEITEM  CB_DELETESTRING
#define CBEM_GETCOMBOCONTROL  (WM_USER+6)
#define CBEM_GETEDITCONTROL  (WM_USER+7)
#define CBEM_SETEXSTYLE  (WM_USER+8)
#define CBEM_SETEXTENDEDSTYLE  (WM_USER+14)
#define CBEM_GETEXSTYLE  (WM_USER+9)
#define CBEM_GETEXTENDEDSTYLE  (WM_USER+9)
#define CBEM_SETUNICODEFORMAT  CCM_SETUNICODEFORMAT
#define CBEM_GETUNICODEFORMAT  CCM_GETUNICODEFORMAT
#define CBEM_HASEDITCHANGED  (WM_USER+10)
#define CBEM_INSERTITEMW  (WM_USER+11)
#define CBEM_SETITEMW  (WM_USER+12)
#define CBEM_GETITEMW  (WM_USER+13)
#define CBEM_SETWINDOWTHEME  CCM_SETWINDOWTHEME

#define CBES_EX_NOEDITIMAGE  0x00000001
#define CBES_EX_NOEDITIMAGEINDENT  0x00000002
#define CBES_EX_PATHWORDBREAKPROC  0x00000004
#define CBES_EX_NOSIZELIMIT  0x00000008
#define CBES_EX_CASESENSITIVE  0x00000010
#define CBES_EX_TEXTENDELLIPSIS      0x00000020

COMBOBOXEXITEMA STRUCT
	mask DD
	iItem INT_PTR
	pszText PTR
	cchTextMax DD
	iImage DD
	iSelectedImage DD
	iOverlay DD
	iIndent DD
	lParam DD
ENDS

#define COMBOBOXEXITEMW COMBOBOXEXITEMA

NMCOMBOBOXEXA STRUCT
	hdr NMHDR
	ceItem COMBOBOXEXITEMA
ENDS

NMCOMBOBOXEXW STRUCT
	hdr NMHDR
	ceItem COMBOBOXEXITEMW
ENDS

#define CBEN_GETDISPINFOA  (CBEN_FIRST-0)
#define CBEN_INSERTITEM  (CBEN_FIRST-1)
#define CBEN_DELETEITEM  (CBEN_FIRST-2)
#define CBEN_BEGINEDIT  (CBEN_FIRST-4)
#define CBEN_ENDEDITA  (CBEN_FIRST-5)
#define CBEN_ENDEDITW  (CBEN_FIRST-6)
#define CBEN_GETDISPINFOW  (CBEN_FIRST-7)
#define CBEN_DRAGBEGINA  (CBEN_FIRST-8)
#define CBEN_DRAGBEGINW  (CBEN_FIRST-9)

#define CBENF_KILLFOCUS  1
#define CBENF_RETURN  2
#define CBENF_ESCAPE  3
#define CBENF_DROPDOWN  4

#define CBEMAXSTRLEN 260

NMCBEDRAGBEGINW STRUCT
	hdr NMHDR
	iItemid DD
	szText DW CBEMAXSTRLEN DUP
ENDS

NMCBEDRAGBEGINA STRUCT
	hdr NMHDR
	iItemid DD
	szText DB CBEMAXSTRLEN DUP
ENDS

NMCBEENDEDITW STRUCT
	hdr NMHDR
	fChanged DD
	iNewSelection DD
	szText DW CBEMAXSTRLEN DUP
	iWhy DD
ENDS

NMCBEENDEDITA STRUCT
	hdr NMHDR
	fChanged DD
	iNewSelection DD
	szText DB CBEMAXSTRLEN DUP
	iWhy DD
ENDS

#IFDEF UNICODE
	#define WC_COMBOBOXEX  WC_COMBOBOXEXW
	#define COMBOBOXEXITEM COMBOBOXEXITEMW
	#define CBEM_INSERTITEM CBEM_INSERTITEMW
	#define CBEM_SETITEM CBEM_SETITEMW
	#define CBEM_GETITEM CBEM_GETITEMW
	#define NMCOMBOBOXEX NMCOMBOBOXEXW
	#define CBEN_GETDISPINFO CBEN_GETDISPINFOW
	#define CBEN_ENDEDIT CBEN_ENDEDITW
	#define CBEN_DRAGBEGIN CBEN_DRAGBEGINW
	#define NMCBEDRAGBEGIN NMCBEDRAGBEGINW
	#define NMCBEENDEDIT NMCBEENDEDITW
#else
	#define WC_COMBOBOXEX  WC_COMBOBOXEXA
	#define COMBOBOXEXITEM COMBOBOXEXITEMA
	#define CBEM_INSERTITEM CBEM_INSERTITEMA
	#define CBEM_SETITEM CBEM_SETITEMA
	#define CBEM_GETITEM CBEM_GETITEMA
	#define NMCOMBOBOXEX NMCOMBOBOXEXA
	#define CBEN_GETDISPINFO CBEN_GETDISPINFOA
	#define CBEN_ENDEDIT CBEN_ENDEDITA
	#define CBEN_DRAGBEGIN CBEN_DRAGBEGINA
	#define NMCBEDRAGBEGIN NMCBEDRAGBEGINA
	#define NMCBEENDEDIT NMCBEENDEDITA
#endif

/* Tab Control **************************************************************/

#define WC_TABCONTROLA  A"SysTabControl32"
#define WC_TABCONTROLW  L"SysTabControl32"

#define TCS_SCROLLOPPOSITE  0x0001
#define TCS_BOTTOM  0x0002
#define TCS_RIGHT  0x0002
#define TCS_MULTISELECT  0x0004
#define TCS_FLATBUTTONS  0x0008
#define TCS_FORCEICONLEFT  0x0010
#define TCS_FORCELABELLEFT  0x0020
#define TCS_HOTTRACK  0x0040
#define TCS_VERTICAL  0x0080
#define TCS_TABS  0x0000
#define TCS_BUTTONS  0x0100
#define TCS_SINGLELINE  0x0000
#define TCS_MULTILINE  0x0200
#define TCS_RIGHTJUSTIFY  0x0000
#define TCS_FIXEDWIDTH  0x0400
#define TCS_RAGGEDRIGHT  0x0800
#define TCS_FOCUSONBUTTONDOWN  0x1000
#define TCS_OWNERDRAWFIXED  0x2000
#define TCS_TOOLTIPS  0x4000
#define TCS_FOCUSNEVER  0x8000

#define TCS_EX_FLATSEPARATORS  0x00000001
#define TCS_EX_REGISTERDROP  0x00000002
#define TCIF_TEXT  0x0001
#define TCIF_IMAGE  0x0002
#define TCIF_RTLREADING  0x0004
#define TCIF_PARAM  0x0008
#define TCIF_STATE  0x0010

#define TCIS_BUTTONPRESSED  0x0001
#define TCIS_HIGHLIGHTED  0x0002

#define TCHT_NOWHERE  0x0001
#define TCHT_ONITEMICON  0x0002
#define TCHT_ONITEMLABEL  0x0004
#define TCHT_ONITEM  (TCHT_ONITEMICON|TCHT_ONITEMLABEL)

#define TCM_GETIMAGELIST  (TCM_FIRST+2)
#define TCM_SETIMAGELIST  (TCM_FIRST+3)
#define TCM_GETITEMCOUNT  (TCM_FIRST+4)
#define TCM_GETITEMA  (TCM_FIRST+5)
#define TCM_SETITEMA  (TCM_FIRST+6)
#define TCM_INSERTITEMA  (TCM_FIRST+7)
#define TCM_DELETEITEM  (TCM_FIRST+8)
#define TCM_DELETEALLITEMS  (TCM_FIRST+9)
#define TCM_GETITEMRECT  (TCM_FIRST+10)
#define TCM_GETCURSEL  (TCM_FIRST+11)
#define TCM_SETCURSEL  (TCM_FIRST+12)
#define TCM_HITTEST  (TCM_FIRST+13)
#define TCM_SETITEMEXTRA  (TCM_FIRST+14)
#define TCM_ADJUSTRECT  (TCM_FIRST+40)
#define TCM_SETITEMSIZE  (TCM_FIRST+41)
#define TCM_REMOVEIMAGE  (TCM_FIRST+42)
#define TCM_SETPADDING  (TCM_FIRST+43)
#define TCM_GETROWCOUNT  (TCM_FIRST+44)
#define TCM_GETTOOLTIPS  (TCM_FIRST+45)
#define TCM_SETTOOLTIPS  (TCM_FIRST+46)
#define TCM_GETCURFOCUS  (TCM_FIRST+47)
#define TCM_SETCURFOCUS  (TCM_FIRST+48)
#define TCM_SETMINTABWIDTH  (TCM_FIRST+49)
#define TCM_DESELECTALL  (TCM_FIRST+50)
#define TCM_HIGHLIGHTITEM  (TCM_FIRST+51)
#define TCM_SETEXTENDEDSTYLE  (TCM_FIRST+52)
#define TCM_GETEXTENDEDSTYLE  (TCM_FIRST+53)

#define TCM_GETITEMW  (TCM_FIRST+60)
#define TCM_SETITEMW  (TCM_FIRST+61)
#define TCM_INSERTITEMW  (TCM_FIRST+62)

#define TCM_SETUNICODEFORMAT  CCM_SETUNICODEFORMAT
#define TCM_GETUNICODEFORMAT  CCM_GETUNICODEFORMAT

#define TCN_KEYDOWN  (TCN_FIRST-0)
#define TCN_SELCHANGE  (TCN_FIRST-1)
#define TCN_SELCHANGING  (TCN_FIRST-2)
#define TCN_GETOBJECT  (TCN_FIRST-3)
#define TCN_FOCUSCHANGE  (TCN_FIRST-4)

#define TC_ITEMA TCITEMA
#define TC_ITEMW TCITEMW
#define TC_ITEM TCITEM

#define TC_ITEMHEADERA TCITEMHEADERA
#define TC_ITEMHEADERW TCITEMHEADERW
#define TC_ITEMHEADER TCITEMHEADER

#define TC_HITTESTINFO TCHITTESTINFO
#define TC_KEYDOWN NMTCKEYDOWN

TCITEMHEADERA STRUCT
	mask DD
	lpReserved1 DD
	lpReserved2 DD
	pszText PTR
	cchTextMax DD
	iImage DD
ENDS

#define TCITEMHEADERW TCITEMHEADERA

TCITEMA STRUCT
	mask DD
	UNION
		dwState DD
		lpReserved1 DD
	ENDUNION
	UNION
		dwStateMask DD
		lpReserved2 DD
	ENDUNION
	pszText PTR
	cchTextMax DD
	iImage DD
	lParam LPARAM
ENDS

#define TCITEMW TCITEMA

TCHITTESTINFO STRUCT
	pt POINT
	flags DD
ENDS

TCKEYDOWN STRUCT
	hdr NMHDR
	wVKey DW
	flags DD
ENDS

#IFDEF UNICODE
	#define WC_TABCONTROL  WC_TABCONTROLW
	#define TCITEMHEADER TCITEMHEADERW
	#define TCITEM TCITEMW
	#define TCM_GETITEM TCM_GETITEMW
	#define TCM_SETITEM TCM_SETITEMW
	#define TCM_INSERTITEM TCM_INSERTITEMW
#else
	#define WC_TABCONTROL  WC_TABCONTROLA
	#define TCITEMHEADER TCITEMHEADERA
	#define TCITEM TCITEMA
	#define TCM_GETITEM TCM_GETITEMA
	#define TCM_SETITEM TCM_SETITEMA
	#define TCM_INSERTITEM TCM_INSERTITEMA
#endif

/* Animate Control **********************************************************/

#define ANIMATE_CLASSW  L"SysAnimate32"
#define ANIMATE_CLASSA  A"SysAnimate32"

#define ACS_CENTER  0x0001
#define ACS_TRANSPARENT  0x0002
#define ACS_AUTOPLAY  0x0004
#define ACS_TIMER  0x0008

#define ACM_OPENA  (WM_USER+100)
#define ACM_OPENW  (WM_USER+103)
#define ACM_PLAY  (WM_USER+101)
#define ACM_STOP  (WM_USER+102)

#define ACN_START  1
#define ACN_STOP  2

#IFDEF UNICODE
	#define ANIMATE_CLASS  ANIMATE_CLASSW
	#define ACM_OPEN ACM_OPENW
#else
	#define ANIMATE_CLASS  ANIMATE_CLASSA
	#define ACM_OPEN ACM_OPENA
#endif

/* MonthCal Control *********************************************************/

#define MONTHCAL_CLASSW  L"SysMonthCal32"
#define MONTHCAL_CLASSA  A"SysMonthCal32"

#define MCSC_BACKGROUND  0
#define MCSC_TEXT  1
#define MCSC_TITLEBK  2
#define MCSC_TITLETEXT  3
#define MCSC_MONTHBK  4
#define MCSC_TRAILINGTEXT  5

#define MCHT_TITLE  0x00010000
#define MCHT_CALENDAR  0x00020000
#define MCHT_TODAYLINK  0x00030000
#define MCHT_NEXT  0x01000000
#define MCHT_PREV  0x02000000
#define MCHT_NOWHERE  0x00000000
#define MCHT_TITLEBK  (MCHT_TITLE)
#define MCHT_TITLEMONTH  (MCHT_TITLE|0x0001)
#define MCHT_TITLEYEAR  (MCHT_TITLE|0x0002)
#define MCHT_TITLEBTNNEXT  (MCHT_TITLE|MCHT_NEXT|0x0003)
#define MCHT_TITLEBTNPREV  (MCHT_TITLE|MCHT_PREV|0x0003)

#define MCHT_CALENDARBK  (MCHT_CALENDAR)

#define MCHT_CALENDARDATE (MCHT_CALENDAR|0x0001)
#define MCHT_CALENDARDATENEXT (MCHT_CALENDARDATE|MCHT_NEXT)
#define MCHT_CALENDARDATEPREV (MCHT_CALENDARDATE|MCHT_PREV)
#define MCHT_CALENDARDAY (MCHT_CALENDAR|0x0002)
#define MCHT_CALENDARWEEKNUM (MCHT_CALENDAR|0x0003)
#define MCHT_CALENDARDATEMIN (MCHT_CALENDAR | 0x0004)
#define MCHT_CALENDARDATEMAX  (MCHT_CALENDAR | 0x0005)
#define MCHT_CALENDARCONTROL 0x00100000

#define MCS_DAYSTATE  0x0001
#define MCS_MULTISELECT  0x0002
#define MCS_WEEKNUMBERS  0x0004
#define MCS_NOTODAYCIRCLE  0x0008
#define MCS_NOTODAY  0x0010
#define MCS_NOTODAY_PRE_IE4 0x0008
#define MCS_NOTRAILINGDATES  0x0040
#define MCS_SHORTDAYSOFWEEK  0x0080
#define MCS_NOSELCHANGEONNAV 0x0100

#define MCMV_MONTH      0
#define MCMV_YEAR       1
#define MCMV_DECADE     2
#define MCMV_CENTURY    3
#define MCMV_MAX        MCMV_CENTURY

#define MCGIP_CALENDARCONTROL      0
#define MCGIP_NEXT                 1
#define MCGIP_PREV                 2
#define MCGIP_FOOTER               3
#define MCGIP_CALENDAR             4
#define MCGIP_CALENDARHEADER       5
#define MCGIP_CALENDARBODY         6
#define MCGIP_CALENDARROW          7
#define MCGIP_CALENDARCELL         8

#define MCGIF_DATE                 0x00000001
#define MCGIF_RECT                 0x00000002
#define MCGIF_NAME                 0x00000004

#define GMR_VISIBLE  0
#define GMR_DAYSTATE  1

#define MCM_FIRST  0x1000
#define MCM_GETCURSEL  (MCM_FIRST+1)
#define MCM_SETCURSEL  (MCM_FIRST+2)
#define MCM_GETMAXSELCOUNT  (MCM_FIRST+3)
#define MCM_SETMAXSELCOUNT  (MCM_FIRST+4)
#define MCM_GETSELRANGE  (MCM_FIRST+5)
#define MCM_SETSELRANGE  (MCM_FIRST+6)
#define MCM_GETMONTHRANGE  (MCM_FIRST+7)
#define MCM_SETDAYSTATE  (MCM_FIRST+8)
#define MCM_GETMINREQRECT  (MCM_FIRST+9)
#define MCM_SETCOLOR  (MCM_FIRST+10)
#define MCM_GETCOLOR  (MCM_FIRST+11)
#define MCM_SETTODAY  (MCM_FIRST+12)
#define MCM_GETTODAY  (MCM_FIRST+13)
#define MCM_HITTEST  (MCM_FIRST+14)

#define MCM_SETFIRSTDAYOFWEEK  (MCM_FIRST+15)
#define MCM_GETFIRSTDAYOFWEEK  (MCM_FIRST+16)
#define MCM_GETRANGE  (MCM_FIRST+17)
#define MCM_SETRANGE  (MCM_FIRST+18)
#define MCM_GETMONTHDELTA  (MCM_FIRST+19)
#define MCM_SETMONTHDELTA  (MCM_FIRST+20)
#define MCM_GETMAXTODAYWIDTH  (MCM_FIRST+21)
#define MCM_GETCURRENTVIEW (MCM_FIRST + 22)
#define MCM_GETCALENDARCOUNT (MCM_FIRST + 23)
#define MCM_GETCALENDARGRIDINFO (MCM_FIRST + 24)
#define MCM_GETCALID (MCM_FIRST + 27)
#define MCM_SETCALID (MCM_FIRST + 28)
#define MCM_SIZERECTTOMIN (MCM_FIRST + 29)
#define MCM_SETCALENDARBORDER (MCM_FIRST + 30)
#define MCM_GETCALENDARBORDER (MCM_FIRST + 31)
#define MCM_SETCURRENTVIEW (MCM_FIRST + 32)

#define MCM_SETUNICODEFORMAT  CCM_SETUNICODEFORMAT
#define MCM_GETUNICODEFORMAT  CCM_GETUNICODEFORMAT

#define MCN_VIEWCHANGE      (MCN_FIRST - 4)
#define MCN_SELCHANGE       (MCN_FIRST - 3)
#define MCN_GETDAYSTATE     (MCN_FIRST - 1)
#define MCN_SELECT          (MCN_FIRST)

MCGRIDINFO STRUCT
	cbSize DD
	dwPart DD
	dwFlags DD
	iCalendar DD
	iRow DD
	iCol DD
	bSelected DD
	stStart SYSTEMTIME
	stEnd SYSTEMTIME
	rc RECT
	pszName PTR
	cchName DD
ENDS

MCHITTESTINFO STRUCT
	cbSize DD
	pt POINT
	uHit DD
	st SYSTEMTIME
#IFDEF VISTA
	rc RECT
	iOffset DD
	iRow DD
	iCol DD
#ENDIF
ENDS

NMSELCHANGE STRUCT
	nmhdr NMHDR
	stSelStart SYSTEMTIME
	stSelEnd SYSTEMTIME
ENDS

NMDAYSTATE STRUCT
	nmhdr NMHDR
	stStart SYSTEMTIME
	cDayState DD
	prgDayState PTR
ENDS

#IFDEF UNICODE
	#define MONTHCAL_CLASS  MONTHCAL_CLASSW
#else
	#define MONTHCAL_CLASS  MONTHCAL_CLASSA
#endif

/* DateTime Picker Control **************************************************/

#define DATETIMEPICK_CLASSW  L"SysDateTimePick32"
#define DATETIMEPICK_CLASSA  A"SysDateTimePick32"

#define DTS_UPDOWN  0x0001
#define DTS_SHOWNONE  0x0002
#define DTS_SHORTDATEFORMAT 0x0000
#define DTS_LONGDATEFORMAT  0x0004
#define DTS_SHORTDATECENTURYFORMAT 0x000C
#define DTS_TIMEFORMAT  0x0009
#define DTS_APPCANPARSE  0x0010
#define DTS_RIGHTALIGN  0x0020

#define GDTR_MIN  0x0001
#define GDTR_MAX  0x0002

#define GDT_ERROR  -1
#define GDT_VALID  0
#define GDT_NONE  1

#define DTM_FIRST  0x1000
#define DTM_GETSYSTEMTIME  (DTM_FIRST+1)
#define DTM_SETSYSTEMTIME  (DTM_FIRST+2)
#define DTM_GETRANGE  (DTM_FIRST+3)
#define DTM_SETRANGE  (DTM_FIRST+4)
#define DTM_SETFORMATA  (DTM_FIRST+5)
#define DTM_SETMCCOLOR  (DTM_FIRST+6)
#define DTM_GETMCCOLOR  (DTM_FIRST+7)
#define DTM_GETMONTHCAL  (DTM_FIRST+8)
#define DTM_SETMCFONT  (DTM_FIRST+9)
#define DTM_GETMCFONT  (DTM_FIRST+10)
#define DTM_SETMCSTYLE    (DTM_FIRST + 11)
#define DTM_GETMCSTYLE    (DTM_FIRST + 12)
#define DTM_CLOSEMONTHCAL (DTM_FIRST + 13)
#define DTM_GETDATETIMEPICKERINFO (DTM_FIRST + 14)
#define DTM_GETIDEALSIZE (DTM_FIRST + 15)

#define DTM_SETFORMATW  (DTM_FIRST+50)

#define DTN_DATETIMECHANGE  (DTN_FIRST2 - 6)
#define DTN_USERSTRINGA  (DTN_FIRST2 - 5)
#define DTN_USERSTRINGW  (DTN_FIRST - 5)
#define DTN_WMKEYDOWNA  (DTN_FIRST2 - 4)
#define DTN_WMKEYDOWNW  (DTN_FIRST - 4)
#define DTN_FORMATA  (DTN_FIRST2 - 3)
#define DTN_FORMATW  (DTN_FIRST - 3)
#define DTN_FORMATQUERYA  (DTN_FIRST2 - 2)
#define DTN_FORMATQUERYW (DTN_FIRST - 2)
#define DTN_DROPDOWN    (DTN_FIRST2 - 1)
#define DTN_CLOSEUP     (DTN_FIRST2)

NMDATETIMECHANGE STRUCT
	nmhdr NMHDR
	dwFlags DD
	st SYSTEMTIME
ENDS

NMDATETIMESTRINGA STRUCT
	nmhdr NMHDR
	pszUserString PTR
	st SYSTEMTIME
	dwFlags DD
ENDS

#define NMDATETIMESTRINGW NMDATETIMESTRINGA

NMDATETIMEWMKEYDOWNA STRUCT
	nmhdr NMHDR
	nVirtKey DD
	pszFormat PTR
	st SYSTEMTIME
ENDS

#define NMDATETIMEWMKEYDOWNW NMDATETIMEWMKEYDOWNA

NMDATETIMEFORMATA STRUCT
	nmhdr NMHDR
	pszFormat PTR
	st SYSTEMTIME
	pszDisplay PTR
	szDisplay DB 64 DUP
ENDS

NMDATETIMEFORMATW STRUCT
	nmhdr NMHDR
	pszFormat PTR
	st SYSTEMTIME
	pszDisplay PTR
	szDisplay DW 64 DUP
ENDS

NMDATETIMEFORMATQUERYA STRUCT
	nmhdr NMHDR
	pszFormat PTR
	szMax SIZE
ENDS

#define NMDATETIMEFORMATQUERYW NMDATETIMEFORMATQUERYA

#IFDEF UNICODE
	#define DATETIMEPICK_CLASS  DATETIMEPICK_CLASSW
	#define DTM_SETFORMAT DTM_SETFORMATW
	#define DTN_USERSTRING DTN_USERSTRINGW
	#define NMDATETIMESTRING NMDATETIMESTRINGW
	#define DTN_WMKEYDOWN DTN_WMKEYDOWNW
	#define NMDATETIMEWMKEYDOWN NMDATETIMEWMKEYDOWNW
	#define DTN_FORMAT DTN_FORMATW
	#define NMDATETIMEFORMAT NMDATETIMEFORMATW
	#define DTN_FORMATQUERY DTN_FORMATQUERYW
	#define NMDATETIMEFORMATQUERY NMDATETIMEFORMATQUERYW
#else
	#define DATETIMEPICK_CLASS  DATETIMEPICK_CLASSA
	#define DTM_SETFORMAT DTM_SETFORMATA
	#define DTN_USERSTRING DTN_USERSTRINGA
	#define NMDATETIMESTRING NMDATETIMESTRINGA
	#define DTN_WMKEYDOWN DTN_WMKEYDOWNA
	#define NMDATETIMEWMKEYDOWN NMDATETIMEWMKEYDOWNA
	#define DTN_FORMAT DTN_FORMATA
	#define NMDATETIMEFORMAT NMDATETIMEFORMATA
	#define DTN_FORMATQUERY DTN_FORMATQUERYA
	#define NMDATETIMEFORMATQUERY NMDATETIMEFORMATQUERYA
#endif


/* IP Address edit control **************************************************/

#define WC_IPADDRESSW  L"SysIPAddress32"
#define WC_IPADDRESSA  A"SysIPAddress32"

#define IPM_CLEARADDRESS  (WM_USER+100)
#define IPM_SETADDRESS  (WM_USER+101)
#define IPM_GETADDRESS  (WM_USER+102)
#define IPM_SETRANGE  (WM_USER+103)
#define IPM_SETFOCUS  (WM_USER+104)
#define IPM_ISBLANK  (WM_USER+105)

#define IPN_FIELDCHANGED IPN_FIRST

NMIPADDRESS STRUCT
	hdr NMHDR
	iField DD
	iValue DD
ENDS

#IFDEF UNICODE
	#define WC_IPADDRESS  WC_IPADDRESSW
#else
	#define WC_IPADDRESS  WC_IPADDRESSA
#endif

/* Pager Control ************************************************************/

#define WC_PAGESCROLLERW  L"SysPager"
#define WC_PAGESCROLLERA  A"SysPager"

#define PGS_VERT  0x00000000
#define PGS_HORZ  0x00000001
#define PGS_AUTOSCROLL  0x00000002
#define PGS_DRAGNDROP  0x00000004

#define PGF_INVISIBLE  0
#define PGF_NORMAL  1
#define PGF_GRAYED  2
#define PGF_DEPRESSED  4
#define PGF_HOT  8

#define PGB_TOPORLEFT  0
#define PGB_BOTTOMORRIGHT  1

#define PGF_SCROLLUP  1
#define PGF_SCROLLDOWN  2
#define PGF_SCROLLLEFT  4
#define PGF_SCROLLRIGHT  8

#define PGK_SHIFT  1
#define PGK_CONTROL  2
#define PGK_MENU  4

#define PGF_CALCWIDTH  1
#define PGF_CALCHEIGHT  2

#define PGM_SETCHILD  (PGM_FIRST+1)
#define PGM_RECALCSIZE  (PGM_FIRST+2)
#define PGM_FORWARDMOUSE  (PGM_FIRST+3)
#define PGM_SETBKCOLOR  (PGM_FIRST+4)
#define PGM_GETBKCOLOR  (PGM_FIRST+5)
#define PGM_SETBORDER  (PGM_FIRST+6)
#define PGM_GETBORDER  (PGM_FIRST+7)
#define PGM_SETPOS  (PGM_FIRST+8)
#define PGM_GETPOS  (PGM_FIRST+9)
#define PGM_SETBUTTONSIZE  (PGM_FIRST+10)
#define PGM_GETBUTTONSIZE  (PGM_FIRST+11)
#define PGM_GETBUTTONSTATE  (PGM_FIRST+12)
#define PGM_GETDROPTARGET  CCM_GETDROPTARGET

#define PGN_SCROLL (PGN_FIRST-1)
#define PGN_CALCSIZE (PGN_FIRST-2)
#define PGN_HOTITEMCHANGE (PGN_FIRST-3)

NMPGSCROLL STRUCT
	hdr NMHDR
	fwKeys DW
	rcParent RECT
	iDir DD
	iXpos DD
	iYpos DD
	iScroll DD
ENDS

NMPGCALCSIZE STRUCT
	hdr NMHDR
	dwFlag DD
	iWidth DD
	iHeight DD
ENDS

#IFDEF UNICODE
	#define WC_PAGESCROLLER  WC_PAGESCROLLERW
#else
	#define WC_PAGESCROLLER  WC_PAGESCROLLERA
#endif

/* Native Font Control ******************************************************/

#define WC_NATIVEFONTCTLW  L"NativeFontCtl"
#define WC_NATIVEFONTCTLA  A"NativeFontCtl"

#define NFS_EDIT  0x0001
#define NFS_STATIC  0x0002
#define NFS_LISTCOMBO  0x0004
#define NFS_BUTTON  0x0008
#define NFS_ALL  0x0010
#define NFS_USEFONTASSOC  0x0020

#IFDEF UNICODE
	#define WC_NATIVEFONTCTL  WC_NATIVEFONTCTLW
#else
	#define WC_NATIVEFONTCTL  WC_NATIVEFONTCTLA
#endif

/* Button Control ***********************************************************/

#define WC_BUTTONA  A"Button"
#define WC_BUTTONW  L"Button"

#define BUTTON_IMAGELIST_ALIGN_LEFT  0
#define BUTTON_IMAGELIST_ALIGN_RIGHT  1
#define BUTTON_IMAGELIST_ALIGN_TOP  2
#define BUTTON_IMAGELIST_ALIGN_BOTTOM  3
#define BUTTON_IMAGELIST_ALIGN_CENTER  4

#define BCM_GETIDEALSIZE  (BCM_FIRST+0x0001)
#define BCM_SETIMAGELIST  (BCM_FIRST+0x0002)
#define BCM_GETIMAGELIST  (BCM_FIRST+0x0003)
#define BCM_SETTEXTMARGIN  (BCM_FIRST+0x0004)
#define BCM_GETTEXTMARGIN  (BCM_FIRST+0x0005)
#define BCM_SETDROPDOWNSTATE     (BCM_FIRST + 0x0006)
#define BCM_SETSPLITINFO         (BCM_FIRST + 0x0007)
#define BCM_GETSPLITINFO         (BCM_FIRST + 0x0008)
#define BCM_SETNOTE              (BCM_FIRST + 0x0009)
#define BCM_GETNOTE              (BCM_FIRST + 0x000A)
#define BCM_GETNOTELENGTH        (BCM_FIRST + 0x000B)
#define BCM_SETSHIELD            (BCM_FIRST + 0x000C)

#define BCN_HOTITEMCHANGE (BCN_FIRST+0x0001)
#define BCN_DROPDOWN (BCN_FIRST + 0x0002)

#define BST_HOT  0x0200
#define BST_DROPDOWNPUSHED      0x0400

// BUTTON STYLES
#define BS_SPLITBUTTON          0x0000000CL
#define BS_DEFSPLITBUTTON       0x0000000DL
#define BS_COMMANDLINK          0x0000000EL
#define BS_DEFCOMMANDLINK       0x0000000FL

// SPLIT BUTTON INFO mask flags
#define BCSIF_GLYPH             0x0001
#define BCSIF_IMAGE             0x0002
#define BCSIF_STYLE             0x0004
#define BCSIF_SIZE              0x0008

// SPLIT BUTTON STYLE flags
#define BCSS_NOSPLIT            0x0001
#define BCSS_STRETCH            0x0002
#define BCSS_ALIGNLEFT          0x0004
#define BCSS_IMAGE              0x0008

#define BCCL_NOGLYPH -1

BUTTON_SPLITINFO STRUCT
	mask DD
	himlGlyph HANDLE
	uSplitStyle DD
	size SIZE
ENDS

BUTTON_IMAGELIST STRUCT
	himl HANDLE
	margin RECT
	uAlign DD
ENDS

NMBCHOTITEM STRUCT
	hdr NMHDR
	dwFlags DD
ENDS

#IFDEF UNICODE
	#define WC_BUTTON  WC_BUTTONW
#else
	#define WC_BUTTON  WC_BUTTONA
#endif

/* Static Control ***********************************************************/

#define WC_STATICA  A"Static"
#define WC_STATICW  L"Static"

#IFDEF UNICODE
	#define WC_STATIC  WC_STATICW
#else
	#define WC_STATIC  WC_STATICA
#endif

/* Edit Control *************************************************************/

#define WC_EDITA  A"Edit"
#define WC_EDITW  L"Edit"

#define EM_SETCUEBANNER  (ECM_FIRST+1)
#define EM_GETCUEBANNER  (ECM_FIRST+2)
#define EM_SHOWBALLOONTIP  (ECM_FIRST+3)
#define EM_HIDEBALLOONTIP  (ECM_FIRST+4)
#define EM_SETHILITE        (ECM_FIRST + 5)
#define EM_GETHILITE        (ECM_FIRST + 6)

EDITBALLOONTIP STRUCT
	cbStruct DD
	pszTitle PTR
	pszText PTR
	ttiIcon DD
ENDS

#IFDEF UNICODE
	#define WC_EDIT  WC_EDITW
#else
	#define WC_EDIT  WC_EDITA
#endif

/* Listbox Control **********************************************************/

#define WC_LISTBOXA  A"ListBox"
#define WC_LISTBOXW  L"ListBox"

#IFDEF UNICODE
	#define WC_LISTBOX  WC_LISTBOXW
#else
	#define WC_LISTBOX  WC_LISTBOXA
#endif

/* Combobox Control *********************************************************/

#define WC_COMBOBOXA  A"ComboBox"
#define WC_COMBOBOXW  L"ComboBox"

#define CB_SETMINVISIBLE        (CBM_FIRST + 1)
#define CB_GETMINVISIBLE        (CBM_FIRST + 2)
#define CB_SETCUEBANNER         (CBM_FIRST + 3)
#define CB_GETCUEBANNER         (CBM_FIRST + 4)

#IFDEF UNICODE
	#define WC_COMBOBOX  WC_COMBOBOXW
#else
	#define WC_COMBOBOX  WC_COMBOBOXA
#endif

/* Scrollbar Control ********************************************************/

#define WC_SCROLLBARA  A"ScrollBar"
#define WC_SCROLLBARW  L"ScrollBar"

#IFDEF UNICODE
	#define WC_SCROLLBAR  WC_SCROLLBARW
#else
	#define WC_SCROLLBAR  WC_SCROLLBARA
#endif

/* SysLink Control **********************************************************/

#define INVALID_LINK_INDEX  (-1)
#define MAX_LINKID_TEXT  48
#define L_MAX_URL_LENGTH  (2048 + 32 + 3)

#define WC_LINK  L"SysLink"

#define LWS_TRANSPARENT  0x0001
#define LWS_IGNORERETURN  0x0002
#define LWS_NOPREFIX        0x0004
#define LWS_USEVISUALSTYLE  0x0008
#define LWS_USECUSTOMTEXT   0x0010
#define LWS_RIGHT           0x0020

#define LIF_ITEMINDEX  0x00000001
#define LIF_STATE  0x00000002
#define LIF_ITEMID  0x00000004
#define LIF_URL  0x00000008

#define LIS_FOCUSED  0x00000001
#define LIS_ENABLED  0x00000002
#define LIS_VISITED  0x00000004
#define LIS_HOTTRACK        0x00000008
#define LIS_DEFAULTCOLORS   0x00000010

LITEM STRUCT
	mask DD
	iLink DD
	state DD
	stateMask DD
	szID DW MAX_LINKID_TEXT DUP
	szUrl DW L_MAX_URL_LENGTH DUP
ENDS

LHITTESTINFO STRUCT
	pt POINT
	item LITEM
ENDS

NMLINK STRUCT
	hdr NMHDR
	item LITEM
ENDS

#define LM_HITTEST  (WM_USER+0x300)
#define LM_GETIDEALHEIGHT  (WM_USER+0x301)
#define LM_SETITEM  (WM_USER+0x302)
#define LM_GETITEM  (WM_USER+0x303)
#define LM_GETIDEALSIZE  (LM_GETIDEALHEIGHT)

/* Task Dialog **************************************************************/

TDF_ENABLE_HYPERLINKS               = 0x0001
TDF_USE_HICON_MAIN                  = 0x0002
TDF_USE_HICON_FOOTER                = 0x0004
TDF_ALLOW_DIALOG_CANCELLATION       = 0x0008
TDF_USE_COMMAND_LINKS               = 0x0010
TDF_USE_COMMAND_LINKS_NO_ICON       = 0x0020
TDF_EXPAND_FOOTER_AREA              = 0x0040
TDF_EXPANDED_BY_DEFAULT             = 0x0080
TDF_VERIFICATION_FLAG_CHECKED       = 0x0100
TDF_SHOW_PROGRESS_BAR               = 0x0200
TDF_SHOW_MARQUEE_PROGRESS_BAR       = 0x0400
TDF_CALLBACK_TIMER                  = 0x0800
TDF_POSITION_RELATIVE_TO_WINDOW     = 0x1000
TDF_RTL_LAYOUT                      = 0x2000
TDF_NO_DEFAULT_RADIO_BUTTON         = 0x4000
TDF_CAN_BE_MINIMIZED                = 0x8000

TDM_NAVIGATE_PAGE                   = WM_USER+101
TDM_CLICK_BUTTON                    = WM_USER+102
TDM_SET_MARQUEE_PROGRESS_BAR        = WM_USER+103
TDM_SET_PROGRESS_BAR_STATE          = WM_USER+104
TDM_SET_PROGRESS_BAR_RANGE          = WM_USER+105
TDM_SET_PROGRESS_BAR_POS            = WM_USER+106
TDM_SET_PROGRESS_BAR_MARQUEE        = WM_USER+107
TDM_SET_ELEMENT_TEXT                = WM_USER+108
TDM_CLICK_RADIO_BUTTON              = WM_USER+110
TDM_ENABLE_BUTTON                   = WM_USER+111
TDM_ENABLE_RADIO_BUTTON             = WM_USER+112
TDM_CLICK_VERIFICATION              = WM_USER+113
TDM_UPDATE_ELEMENT_TEXT             = WM_USER+114
TDM_SET_BUTTON_ELEVATION_REQUIRED_STATE = WM_USER+115
TDM_UPDATE_ICON                     = WM_USER+116

TDN_CREATED                         = 0
TDN_NAVIGATED                       = 1
TDN_BUTTON_CLICKED                  = 2
TDN_HYPERLINK_CLICKED               = 3
TDN_TIMER                           = 4
TDN_DESTROYED                       = 5
TDN_RADIO_BUTTON_CLICKED            = 6
TDN_DIALOG_CONSTRUCTED              = 7
TDN_VERIFICATION_CLICKED            = 8
TDN_HELP                            = 9
TDN_EXPANDO_BUTTON_CLICKED          = 10

TASKDIALOG_BUTTON STRUCT
	ButtonID DD
	szButtonText PTR
ENDS

TDE_CONTENT = 0
TDE_EXPANDED_INFORMATION = 1
TDE_FOOTER = 2
TDE_MAIN_INSTRUCTION = 3

#define TD_WARNING_ICON -1
#define TD_ERROR_ICON -2
#define TD_INFORMATION_ICON -3
#define TD_SHIELD_ICON -4

TDIE_ICON_MAIN = 0
TDIE_ICON_FOOTER = 1

TDCBF_OK_BUTTON            = 0x0001
TDCBF_YES_BUTTON           = 0x0002
TDCBF_NO_BUTTON            = 0x0004
TDCBF_CANCEL_BUTTON        = 0x0008
TDCBF_RETRY_BUTTON         = 0x0010
TDCBF_CLOSE_BUTTON         = 0x0020

TASKDIALOGCONFIG STRUCT
	cbSize DD
	hwndParent HANDLE
	hInstance HANDLE
	dwFlags DD
	dwCommonButtons DD
	pszWindowTitle PTR
	UNION
		hMainIcon HANDLE
		pszMainIcon PTR
	ENDUNION
	pszMainInstruction PTR
	pszContent PTR
	cButtons DD
	pButtons PTR
	nDefaultButton DD
	cRadioButtons DD
	pRadioButtons PTR
	nDefaultRadioButton DD
	pszVerificationText PTR
	pszExpandedInformation PTR
	pszExpandedControlText PTR
	pszCollapsedControlText PTR
	UNION
		hFooterIcon HANDLE
		pszFooterIcon PTR
	ENDUNION
	pszFooter PTR
	pfCallback PTR
	lpCallbackData LONG_PTR
	cxWidth DD
ENDS

/* Dynamic Pointer Array, Dynamic Structure Array ***************************/

#define DA_LAST  (0x7FFFFFFF)
#define DPA_APPEND  (0x7fffffff)
#define DPA_ERR  (-1)

#define DSA_APPEND  (0x7fffffff)
#define DSA_ERR  (-1)

#define DPAS_SORTED  0x0001
#define DPAS_INSERTBEFORE  0x0002
#define DPAS_INSERTAFTER  0x0004

DPASTREAMINFO STRUCT
	iPos DD
	pvItem PTR
ENDS

#define DPAM_SORTED             0x00000001
#define DPAM_NORMAL             0x00000002
#define DPAM_UNION              0x00000004
#define DPAM_INTERSECT          0x00000008

#define DPAMM_MERGE     1
#define DPAMM_DELETE    2
#define DPAMM_INSERT    3



/* TrackMouseEvent **********************************************************/

#define WM_MOUSEHOVER  0x02A1
#define WM_MOUSELEAVE  0x02A3

#define TME_HOVER  0x00000001
#define TME_LEAVE  0x00000002
#define TME_NONCLIENT  0x00000010
#define TME_QUERY  0x40000000
#define TME_CANCEL  0x80000000

#define HOVER_DEFAULT  0xFFFFFFFF

TRACKMOUSEEVENT STRUCT
	cbSize DD
	dwFlags DD
	hwndTrack HANDLE
	dwHoverTime DD
ENDS

/* Flat scrollbar API *******************************************************/

#define WSB_PROP_CYVSCROLL  0x00000001
#define WSB_PROP_CXHSCROLL  0x00000002
#define WSB_PROP_CYHSCROLL  0x00000004
#define WSB_PROP_CXVSCROLL  0x00000008
#define WSB_PROP_CXHTHUMB  0x00000010
#define WSB_PROP_CYVTHUMB  0x00000020
#define WSB_PROP_VBKGCOLOR  0x00000040
#define WSB_PROP_HBKGCOLOR  0x00000080
#define WSB_PROP_VSTYLE  0x00000100
#define WSB_PROP_HSTYLE  0x00000200
#define WSB_PROP_WINSTYLE  0x00000400
#define WSB_PROP_PALETTE  0x00000800
#define WSB_PROP_MASK  0x00000FFF

#define FSB_FLAT_MODE  2
#define FSB_ENCARTA_MODE  1
#define FSB_REGULAR_MODE  0

#define FlatSB_SetScrollPropPtr FlatSB_SetScrollProp

LIM_SMALL = 0
LIM_LARGE = 1

/* End of standard header ****************************************************/

CREATEMRULIST STRUCT
	cbSize		DD ; Size of this structure in BYTES
	nMaxItems	DD ; Maximum number of items in list
	dwFlags		DD ; Use the flags defined above
	hKey		HANDLE ; A registry key to save the list (eg HKEY_LOCAL_MACHINE)
	lpszSubKey	PTR ; Pointer to a subkey to save the list (eg Software\Company\Program\Preferences\MRUList")
	lpfnCompare	PTR ; Pointer to an application defined callback to compare the items (for FindMRUString)
ENDS

#DEFINE MRUINFO CREATEMRULIST

#IFDEF CCUSEORDINALS
	; Interprocess memory allocation for 9x
	#IFDEF WIN9X
		#define SharedAlloc COMCTL32.DLL:71 ; cb ; returns pv
		#define SharedReAlloc COMCTL32.DLL:72 ; pv,cb ; returns pv
		#define SharedFree COMCTL32.DLL:73 ; pv ; no return
		#define SharedGetSize COMCTL32.DLL:74 ; pv ; returns size
	#ENDIF

	#define MRUF_STRING_LIST 	0 ; String list (most common)
	#define MRUF_BINARY_LIST 	1 ; Binary data
	#define MRUF_DELAYED_SAVE 	2 ; No idea what this does

	#DEFINE CREATEMRULISTA CREATEMRULIST
	#DEFINE CREATEMRULISTW CREATEMRULIST

	;4.00
	#IF COMCTLVER >= 400
		#define CreateMRUListA COMCTL32.DLL:151
		#define FreeMRUList COMCTL32.DLL:152
		#define AddMRUStringA COMCTL32.DLL:153
		#define EnumMRUListA  COMCTL32.DLL:154
		#define FindMRUStringA  COMCTL32.DLL:155
		#define DelMRUString  COMCTL32.DLL:156
		#define AddMRUData  COMCTL32.DLL:167
		#define FindMRUData  COMCTL32.DLL:169

		#define DPA_Clone COMCTL32.DLL:331
		#define DPA_Create COMCTL32.DLL:328
		#define DPA_CreateEx COMCTL32.DLL:340
		#define DPA_DeleteAllPtrs COMCTL32.DLL:337
		#define DPA_DeletePtr COMCTL32.DLL:336
		#define DPA_Destroy COMCTL32.DLL:329
		#define DPA_GetPtr COMCTL32.DLL:332
		#define DPA_GetPtrIndex COMCTL32.DLL:333
		#define DPA_Grow COMCTL32.DLL:330
		#define DPA_InsertPtr COMCTL32.DLL:334
		#define DPA_Search COMCTL32.DLL:339
		#define DPA_SetPtr COMCTL32.DLL:335
		#define DPA_Sort COMCTL32.DLL:338

		#define DSA_Create COMCTL32.DLL:320
		#define DSA_DeleteAllItems COMCTL32.DLL:327
		#define DSA_DeleteItem COMCTL32.DLL:326
		#define DSA_Destroy COMCTL32.DLL:321

		#define DSA_GetItem COMCTL32.DLL:322
		#define DSA_GetItemPtr COMCTL32.DLL:323
		#define DSA_InsertItem COMCTL32.DLL:324
		#define DSA_SetItem COMCTL32.DLL:325
	#ENDIF

	; 4.70+
	#IF COMCTLVER >= 470
		#define IntlStrEqWorkerA COMCTL32.DLL:376
		#define IntlStrEqWorkerW COMCTL32.DLL:377
		#define AddMRUStringW COMCTL32.DLL:401
		#define EnumMRUListW COMCTL32.DLL:403
		#define FindMRUStringW COMCTL32.DLL:402
		#define CreateMRUListW COMCTL32.DLL:400
	#ENDIF

	; 4.71+
	#IF COMCTLVER >= 471
		#define CreateMRUListLazyA COMCTL32.DLL:157
		#define CreateMRUListLazyW COMCTL32.DLL:404

		#define DPA_DestroyCallback COMCTL32.DLL:386
		#define DPA_EnumCallback COMCTL32.DLL:385
		#define DPA_LoadStream COMCTL32.DLL:9
		#define DPA_Merge COMCTL32.DLL:11
		#define DPA_SaveStream COMCTL32.DLL:10

		#define DSA_DestroyCallback COMCTL32.DLL:388
		#define DSA_EnumCallback COMCTL32.DLL:387
	#ENDIF

	; 4.72+
	#IF COMCTLVER >= 472
		#define SetWindowSubclass COMCTL32.DLL:410
		#define GetWindowSubclass COMCTL32.DLL:411
		#define RemoveWindowSubclass COMCTL32.DLL:412
		#define DefSubclassProc COMCTL32.DLL:413
	#ENDIF

	; 5.80+
	#IF COMCTLVER >= 580
		#define MirrorIcon COMCTL32.DLL:414
		#define DrawTextWrap COMCTL32.DLL:415
		#define DrawTextExPrivWrap COMCTL32.DLL:416
		#define ExtTextOutWrap COMCTL32.DLL:417
		#define GetCharWidthWrap COMCTL32.DLL:418
		#define GetTextExtentPointWrap COMCTL32.DLL:419
		#define GetTextExtentPoint32Wrap COMCTL32.DLL:420
		#define TextOutWrap COMCTL32.DLL:421
	#ENDIF

	; 6.10+
	#IF COMCTLVER >= 610
		#define CreateCheckBoxImageList COMCTL32.DLL:18
		#define DestroyPropsheetPageArray COMCTL32.DLL:165
		#define CreateDUIPropertySheetPage COMCTL32.DLL:174
		#define GetTitleFromPropSheetHeader COMCTL32.DLL:391
		#define PremultiplyAlphaChannel COMCTL32.DLL:392
		#define CreateSmallerIcon COMCTL32.DLL:393
		#define Markup_Create COMCTL32.DLL:395
	#ENDIF

	#IFDEF UNICODE
		#define CreateMRUList CreateMRUListW
		#define AddMRUString AddMRUStringW
		#define EnumMRUList EnumMRUListW
		#define FindMRUString FindMRUStringW
		#define CreateMRUListLazy CreateMRUListLazyW
	#ELSE
		#define CreateMRUList CreateMRUListA
		#define AddMRUString AddMRUStringA
		#define EnumMRUList EnumMRUListA
		#define FindMRUString FindMRUStringA
		#define CreateMRUListLazy CreateMRUListLazyA
	#ENDIF
#ENDIF

#IFDEF CCMOUSEEVENT
	#define TrackMouseEvent COMCTL32.DLL:_TrackMouseEvent
#ENDIF

#ENDIF // COMMCTRL_H
