#ifndef WINDEF_H
#define WINDEF_H

#DEFINE WINDEF_H_REQVER 100

/* Windows Basic Type Definitions */

/*
Switches used
NT_EXCLUDED = do not include winnt.h
*/

/*
Dependancies
winnt.h
*/

#define MAX_PATH  260

#DEFINE ATOM DW
#DEFINE BOOL DD
#DEFINE BOOLEAN DB
#DEFINE BYTE DB
#DEFINE CHAR DB
#DEFINE COLORREF DD
#DEFINE DWORD DD
#DEFINE DWORDLONG DQ
#DEFINE DWORD32 DD
#DEFINE DWORD64 DQ
#DEFINE LRESULT DD

#IFDEF WIN64
	#DEFINE INT_PTR DQ
	#DEFINE UINT_PTR DQ
	#DEFINE LONG_PTR DQ
	#DEFINE ULONG_PTR DQ
	#DEFINE DWORD_PTR DQ
	#DEFINE HALF_PTR DD
#ELSE
	#DEFINE INT_PTR DD
	#DEFINE UINT_PTR DD
	#DEFINE LONG_PTR DD
	#DEFINE ULONG_PTR DD
	#DEFINE DWORD_PTR DD
	#DEFINE HALF_PTR DW
#ENDIF

#DEFINE FLOAT DD
#DEFINE DOUBLE DQ
#DEFINE FXPT2DOT30 DD

#ifdef WIN64
	#DEFINE SIZE_T DQ
#else
	#DEFINE SIZE_T DD
#endif

#ifdef WIN64
	#DEFINE HANDLE DQ
#else
	#DEFINE HANDLE DD
#endif

#DEFINE LPARAM DD
#DEFINE WPARAM DD

#DEFINE INT32 DD
#DEFINE INT64 DQ
#DEFINE LANGID DW
#DEFINE LCID DD
#DEFINE LCTYPE DD
#DEFINE LGRPID DD
#DEFINE LONG DD
#DEFINE LONGLONG DQ
#DEFINE LONG32 DD
#DEFINE LONG64 DQ

#DEFINE SHORT DW
#DEFINE WORD DW

#IFDEF UNICODE
	#DEFINE TBYTE DW
	#DEFINE TCHAR DW
#ELSE
	#DEFINE TBYTE DB
	#DEFINE TCHAR DB
#ENDIF

#ifdef WIN64
	#DEFINE PTR DQ
#else
	#DEFINE PTR DD
#endif

#DEFINE USN DQ
#DEFINE WCHAR DW

#ifndef NULL
#define NULL  0
#endif

#ifndef FALSE
#define FALSE  0
#endif

#ifndef TRUE
#define TRUE  1
#endif

#ifndef NT_EXCLUDED
	#IFNDEF WINNT_H
		#include winnt.h // WIN3264 - VISTA
	#ENDIF
#endif

#define HFILE_ERROR -1

UNICODE_STRING STRUCT
	Length DW
	MaximumLength DW
	Buffer PTR
ENDS

#IFNDEF RECT
	RECT STRUCT
		left DD
		top DD
		right DD
		bottom DD
	ENDS
#ENDIF

#IFNDEF RECTL
	RECTL = RECT
#ENDIF

#IFNDEF POINT
	POINT STRUCT
		x DD
		y DD
	ENDS
#ENDIF

#IFNDEF POINTL
	POINTL STRUCT
		x DD
		y DD
	ENDS
#ENDIF

#IFNDEF SIZE
	SIZE STRUCT
		cx DD
		cy DD
	ENDS
#ENDIF

#IFNDEF SIZEL
	SIZEL STRUCT
		cx DD
		cy DD
	ENDS
#ENDIF

#IFNDEF POINTS
	POINTS STRUCT
		x DW
		y DW
	ENDS
#ENDIF

#define DM_UPDATE  1
#define DM_COPY  2
#define DM_PROMPT  4
#define DM_MODIFY  8

#define DM_IN_BUFFER  DM_MODIFY
#define DM_IN_PROMPT  DM_PROMPT
#define DM_OUT_BUFFER  DM_COPY
#define DM_OUT_DEFAULT  DM_UPDATE

#define DC_FIELDS  1
#define DC_PAPERS  2
#define DC_PAPERSIZE  3
#define DC_MINEXTENT  4
#define DC_MAXEXTENT  5
#define DC_BINS  6
#define DC_DUPLEX  7
#define DC_SIZE  8
#define DC_EXTRA  9
#define DC_VERSION  10
#define DC_DRIVER  11
#define DC_BINNAMES  12
#define DC_ENUMRESOLUTIONS  13
#define DC_FILEDEPENDENCIES  14
#define DC_TRUETYPE  15
#define DC_PAPERNAMES  16
#define DC_ORIENTATION  17
#define DC_COPIES  18

#endif

